class clock
{
        final static int SYSTEM_TIME_GRANULARITY = 1000;  //this might vary depending on the system

        long msecs;    //milliseconds
        int secs;     //seconds
        int mins;     //minutes
        long startMs; //starting milliseconds value (We'll calculate all the other times from this)
        boolean tick = false;  //tells if a second has passed since last tick

        //constructors
        public clock()
        {
                msecs = secs = mins = 0;
                startMs = System.currentTimeMillis();
                tick = false;
        }
        public clock(int m, int s, int ms)
        {
                mins = m;
                secs = s;
                msecs = ms;
                startMs = System.currentTimeMillis();
                tick = false;
        }

        //reset the clock
        public void reset()
        {
                msecs = secs = mins = 0;
                startMs = System.currentTimeMillis();
                tick = false;
        }

        //reset the ticker
        public void unTick()
        {
                tick = false;
        }

        //update the clock with information from the system
        public void update()
        {
                long newMs = System.currentTimeMillis();

                msecs = newMs-startMs;   //get the difference to find the current milliseconds value
                if(msecs >= SYSTEM_TIME_GRANULARITY){
                        tick = true;
                        msecs = msecs-SYSTEM_TIME_GRANULARITY;
                        startMs = newMs;
                        //increment the seconds value..
                        if(++secs >= 60){
                                secs = 0;
                                //increment the minutes..
                                mins++;
                                }
                        }
        }
}
