/* this is a generic template that I use as a starting point for my java applets */
/* yeah, I'm that lazy */

import java.applet.*;
import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;
import java.awt.image.*;
import java.io.*;
import java.net.*;
import java.text.*;
import javax.sound.sampled.*;

public class dcFinal extends Applet implements Runnable, KeyListener, MouseListener, MouseMotionListener
{
        //applet dimensions
        final static int APP_W = 500;
        final static int APP_H = 400;
        final static float FAPP_W = (float)APP_W;
        final static float FAPP_H = (float)APP_H;
		final static int APP_WINDOWBAR_HEIGHT = 29;   //size of the title bar for the window

		final static int SHADOW_OFFSET = 2;           //# of pixels for the shadow's offset

        final static int GAMESTATE_TITLE = -1;
        final static int GAMESTATE_INITIALIZE = 0;
        final static int GAMESTATE_LEVEL_INITIALIZE = 1;
        final static int GAMESTATE_READY = 2;
        final static int GAMESTATE_LEVELUP = 3;
        final static int GAMESTATE_GAMEOVER_BEGIN = 4;
        final static int GAMESTATE_GAMEOVER = 5;
        final static int GAMEMODE_NORMAL = 0;

        final static int MAX_PLAYER_NAME_LENGTH = 32;

        final static int MAX_GAME_ITEMS = 128;
        final static int MAX_ITEM_IMAGES = 16;
        final static int MAX_GAME_PARTICLES = 256;
        final static int MAX_GAME_COLORS = 16;
        final static int MAX_BALL_EMOTIONS = 8;

        final static int DIR_NONE = 0;
        final static int DIR_LEFT = 1;
        final static int DIR_RIGHT = 2;
        final static int DIR_UP = 3;
        final static int DIR_DOWN = 4;

        final static String versionString = "Dot to Dot v02.15.2018.02.18.06a";
		final static String appString = "dcFinal";

        final static int DEFAULT_CREDITS = 3;

        boolean isOnline = false;   //are we playing in a browser?
		boolean isApplication = true;  //are we an application or applet?
		boolean useFullscreen = false; //fullscreen on or off?

        //int gameState = GAMESTATE_INITIALIZE;
        int gameState = GAMESTATE_TITLE;
        int gameMode = GAMEMODE_NORMAL;

        //heads up display dimensions
        int hudW = 100;
        int hudH = APP_H;

        //playing area dimensions
        int playW = APP_W-hudW;
        int playH = APP_H;

        int curScoringMode = 0;
        boolean gotHiScore = false;
        boolean hiScoreEntryDone = false;
        int maxNameLength = 20;

        vertex playFieldPos;
        vertex hudPos = new vertex(APP_W-hudW, 0);   //placement of the heads up display (score, etc.)
        vertex hudScorePos = new vertex(15, 38);
        vertex hudHiScorePos = new vertex(15, 68);
        vertex hudLevelPos = new vertex(15, 158);
        vertex hudStreakPos = new vertex(15, 98);
        vertex hudBestStreakPos = new vertex(15, 128);
        vertex hudCreditsPos = new vertex(15, 165);
        vertex hudEmotionPos = new vertex(50, 348);
        int hudEmotionRadius = 32;

        //hiscore entry stuff
        String playerNameString = "Player 1";  //player name string for hiscore entry

        Thread mainThread = null;        //main thread
        Color borderClearColor = new Color(0, 96, 128);  //border background color
        Color clearColor = new Color(0.85f, 0.85f, 0.85f);  //background color
        Color gridColor = new Color(0.75f, 0.75f, 0.75f);
        Color hudColor = new Color(0.6f,0.6f,0.6f,1.0f);   //the color used for the heads up display

        Image img_scBuff = null;         //screen buffer
        Graphics g_scBuff = null;        //screen buffer graphics context
        Font gameFont = null;
        Font gameSmallFont = null;
        Font hudFont = null;
        int fontW = 8, fontH = 10;
        int smallFontW = 10, smallFontH = 12;
//        Font mySpecialFont = Font.createFont(Font.TRUETYPE_FONT, getClass().getResourceAsStream("myfont.ttf"));
        Image hudImage = null;           //heads up display bitmap

        AverageTimer gameAverageTimer = null;   //average time for display sync

        clock gameClock = new clock();           //game clock

        hiScoreBank gameHiScoreBank = new hiScoreBank();  //game high scores listings
        player gamePlayer = null;                    //the player!
        item[] gameItem = new item[MAX_GAME_ITEMS];  //the items/dots!
        Image[] itemImage = new Image[MAX_ITEM_IMAGES];
        dirtyRectBank gameRectBank = new dirtyRectBank();
		dirtyRectBank gameShadowBank = new dirtyRectBank();
        particle[] gameParticle = new particle[MAX_GAME_PARTICLES];

        int numColors = 6;
        int numItems = 0;
        int numBadItems = 0;
        int curLevel = 0;
        int credits = DEFAULT_CREDITS;
        long score = 0;
        long highestScore = 0;
        long extraCreditScore = 16000;
        int hiScoreStart = 0;
        int numHiScoresShown = 10;
        int hiScoreScrollCount = 0;
        int hiScoreScrolling = 0;
        boolean hiScoreScrollDown = true;
        int hiScoreScrollSpeed = 50;
        int hiScoreStartSpeed = 200;
        int extraCreditMultiplier = 1;
        int curStreak = 0;
        int bestStreak = 0;
        int levelItemIncrement = 4;
        int ballSize = 16;
        int controlType = 1;   //so I can test rotate controls and cardinal controls
        Color[] colorBank = new Color[MAX_GAME_COLORS];
        Image hudBgImage = null;
        int curPowerupDuration = 100; //how many seconds till another powerup drops
        int powerupTimer = 0;        //timer for powerup countdown/up
        int[] numItemsColored = new int[MAX_GAME_COLORS];   //use this to count the # of items of this color currently active
        Image[] ballEmotionImage = new Image[MAX_BALL_EMOTIONS];
        float curItemSpeedChange = 1.0f;
        boolean screenCleared = false;
        boolean itemsStopped = false; //toggle item stoppage (during player's appearance)
        float titleAngle = 0.0f;     //angle of rotating circle on title
        float titleSinAngle = 0.0f;  //angle of sine wave on title
        float titleRad = 80.0f;      //radius of rotating title circle
        float titleDRad = 1.0f;      //rate of change on radius of rotating circle
        float titleDAngle = (float)Math.PI/64;      //rate of rotation
        float titleDSinAngle = (float)Math.PI/32;   //rate of wave motion
        int creditsScale = -1;       //counter for scaling the credits up
        boolean soundOn = true;      //toggle sound
		boolean shadowsOn = false;   //toggle shadows
		int soundMode = 0;           //sound mode (testing)
        int numGameResources = 27;   //# resources used by game (images and sounds)
        int numGameResourcesLoaded;  //# resources currently loaded

		int errorOutputX = 5;        //coordinates for printing error messages to the window
		int errorOutputY = APP_WINDOWBAR_HEIGHT+1;

        //sound effects
/*
        AudioClip soundAbsorbDot = null;
        AudioClip soundBadDot = null;
        AudioClip[] soundDotBounce = new AudioClip[4];
        AudioClip soundTimeSlow = null;
        AudioClip soundTimeSpeed = null;
        AudioClip soundPlayerAppear = null;
        AudioClip soundTick = null;
        AudioClip soundItemAppear = null;
        AudioClip soundBomb = null;
        AudioClip soundBombHit = null;
        AudioClip soundExtraCredit = null;
        AudioClip soundSuddenDeath = null;
*/
		Clip soundAbsorbDot = null;
        Clip soundBadDot = null;
        Clip[] soundDotBounce = new Clip[4];
        Clip soundTimeSlow = null;
        Clip soundTimeSpeed = null;
        Clip soundPlayerAppear = null;
        Clip soundTick = null;
        Clip soundItemAppear = null;
        Clip soundBomb = null;
        Clip soundBombHit = null;
        Clip soundExtraCredit = null;
        Clip soundSuddenDeath = null;

        //applet init sequence
        public void init()
        {
                setBackground(clearColor);  //set bg color
                resize(APP_W, APP_H);       //set applet dimensions

                //create screen buffer
                try{
                        img_scBuff = createImage(APP_W, APP_H);
                        g_scBuff = img_scBuff.getGraphics();
                        }
                catch(Exception e){
                        System.out.println("screen buffer not created..");
                        img_scBuff = null;
                        g_scBuff = null;
                        return;
                        }

                g_scBuff.setColor(clearColor);
                g_scBuff.fillRect(0, 0, APP_W, APP_H);

                //add listeners
                addMouseListener(this);
                addMouseMotionListener(this);
                addKeyListener(this);

                //load saved hiscores
        }

        //start the main thread
        public void start()
        {
                if(mainThread == null){
                        mainThread = new Thread(this);
                        mainThread.start();   //invokes run()
                        }
        }

        //kill the main thread
        public void stop()
        {
                mainThread = null;
        }

        //draw stuff to the screen
        public void paint(Graphics g)
        {
                if(img_scBuff != null){
                        g.drawImage(img_scBuff, 0, 0, this);  //draw the screen buffer to the graphics context
                        }
        }

        //update the supplied graphics context
        public void update(Graphics g)
        {
                paint(g);
        }

        public void run()
        {
                System.out.println("applet starting...");

                if(g_scBuff == null) return; //make sure double buffer created properly

                Graphics g = getGraphics();

                //register font
                g.setFont(gameSmallFont);
                g_scBuff.setFont(gameSmallFont);

                //make sure initialization occurs without incident
                if(!initApp(g)) return;

                System.out.println("entering main loop...");

                //keep looping until the thread is killed
                while(mainThread != null){
                        updateApp();  //handle logic
                        paintApp(g);  //handle display

                        try{   //take a little nap
                                Thread.sleep(10);
                                }catch(InterruptedException e) { stop(); }
                        }

                System.out.println("applet cleanly exited.");
        }

		//convert the stack trace from an exception to a string so we can print it
		String exceptionStackTraceToString(Exception e)
		{
			StringWriter sw = new StringWriter();
			PrintWriter pw = new PrintWriter(sw);
			e.printStackTrace(pw);
			String str = sw.toString(); // stack trace as a string

			return str;
		}

		//audio loading routine, alternate number 2
		Clip loadAudioClipFileAlt2(String filename)
		{
			Clip clip = null;
			try
			{
				URL soundURL = getClass().getClassLoader().getResource(filename);
            	if(soundURL != null)
				{
                	AudioInputStream sound = AudioSystem.getAudioInputStream(soundURL);
             		// load the sound into memory (a Clip)
                	clip = AudioSystem.getClip();
                	clip.open(sound);
            	}
            	else
				{
                	throw new RuntimeException("Sound: file not found: " + filename);
            	}
        	}
        	catch(MalformedURLException e)
			{
            	e.printStackTrace();
            	throw new RuntimeException("Sound: Malformed URL: " + e);
        	}
	        catch(UnsupportedAudioFileException e)
			{
            	e.printStackTrace();
            	throw new RuntimeException("Sound: Unsupported Audio File: " + e);
        	}
        	catch(IOException e)
			{
            	e.printStackTrace();
            	throw new RuntimeException("Sound: Input/Output Error: " + e);
        	}
        	catch(LineUnavailableException e)
			{
            	e.printStackTrace();
            	throw new RuntimeException("Sound: Line Unavailable Exception Error: " + e);
        	}

			return clip;
		}

		//load a clip from a file (alternate method)
		Clip loadAudioClipFileAlt(String filename)
		{
				if(!soundOn) return null;

				File file = null;
				URL url = null;
				AudioInputStream ais = null;
				Clip clip = null;
				AudioFileFormat aff = null;
				AudioFormat af = null;

				URL soundURL = null;
				try
				{
					DataLine.Info daInfo = new DataLine.Info(Clip.class, null);
					try {
								soundURL = getClass().getClassLoader().getResource(filename);

					            ais = AudioSystem.getAudioInputStream(soundURL);
					            DataLine.Info info = new DataLine.Info(Clip.class, ais.getFormat());
					            clip = (Clip)AudioSystem.getLine(info);
					            clip.open(ais);
					            //clip.start();
					        } catch (LineUnavailableException e) {
									String str = null;
									str = exceptionStackTraceToString(e);
									System.out.println(str);
									g_scBuff.setColor(Color.BLACK);
									g_scBuff.drawString(str, errorOutputX, errorOutputY);
					        } catch (UnsupportedAudioFileException e) {
									String str = null;
									str = exceptionStackTraceToString(e);
									System.out.println(str);
									g_scBuff.setColor(Color.BLACK);
									g_scBuff.drawString(str, errorOutputX, errorOutputY);
					        } catch (IOException e) {
									String str = null;
									str = exceptionStackTraceToString(e);
									System.out.println(str);
									g_scBuff.setColor(Color.BLACK);
									g_scBuff.drawString(str, errorOutputX, errorOutputY);
					        }
				}
				catch(Exception e)
				{
					String str = null;
					str = exceptionStackTraceToString(e);
					System.out.println(str);
					g_scBuff.setColor(Color.BLACK);
					g_scBuff.drawString(str, errorOutputX, errorOutputY);
	       		}

				if(clip != null)
				{
					System.out.println("Clip has frame length of " + clip.getFrameLength());
					//clip.setLoopPoints(0, clip.getFrameLength());
				}

				return clip;
		}

		//load a clip from a file
		Clip loadAudioClipFile(String filename)
		{
				if(!soundOn) return null;

				File file = null;
				URL url = null;
				AudioInputStream ais = null;
				Clip clip = null;
				AudioFileFormat aff = null;
				AudioFormat af = null;

				URL soundURL = null;
				try
				{
					soundURL = getClass().getClassLoader().getResource(filename);
					if(soundURL == null){ System.out.println("SoundURL is null. Aborting."); return null; }
					Line.Info linfo = new Line.Info(Clip.class);
					if(linfo == null){ System.out.println("Linfo is null. Aborting."); return null; }
				    Line line = AudioSystem.getLine(linfo);
					if(line == null){ System.out.println("Line is null. Aborting."); return null; }
				    clip = (Clip)line;
					if(clip == null){ System.out.println("Clip is null. Aborting."); return null; }
				    ais = AudioSystem.getAudioInputStream(soundURL);
					if(ais == null){ System.out.println("AIS is null. Aborting."); return null; }
				    clip.open(ais);
				}
				catch(Exception e)
				{
					String str = null;
					str = exceptionStackTraceToString(e);
					g_scBuff.setColor(Color.BLACK);
					g_scBuff.drawString(str, errorOutputX, errorOutputY);
	       		}

				if(clip != null)
				{
					System.out.println("Clip has frame length of " + clip.getFrameLength());
					//clip.setLoopPoints(0, clip.getFrameLength());
				}

				return clip;
		}

		//just a wrapper for the loading method
		Clip loadClip(String filename)
		{
				if(soundMode == 1) return loadAudioClipFile(filename);
				else if(soundMode == 2) return loadAudioClipFileAlt(filename);
				else if(soundMode == 3) return loadAudioClipFileAlt2(filename);

				return null;
		}

        //draw the loading bar..
        void drawLoadingBar(Graphics g, int x, int y, int w, int h, int count, int endCount, Color fillColor, Color outlineColor)
        {
                float ratio = (float)count/endCount;
                g.setColor(fillColor);
                g.fillRect(x, y, (int)(w*ratio), h);
                g.setColor(outlineColor);
                g.drawRect(x, y, w, h);
        }

        //load all the images up before we start going
        void loadGameImages(Graphics g)
        {
                itemImage[0] = loadImageSync("ball0000.png");
                drawLoadingBar(g, fontW*2, fontH*2+2, playW/2, fontH+2, ++numGameResourcesLoaded, numGameResources, Color.BLACK, Color.BLACK);
                itemImage[1] = loadImageSync("ball0100.png");
                drawLoadingBar(g, fontW*2, fontH*2+2, playW/2, fontH+2, ++numGameResourcesLoaded, numGameResources, Color.BLACK, Color.BLACK);
                itemImage[2] = loadImageSync("ball0200.png");
                drawLoadingBar(g, fontW*2, fontH*2+2, playW/2, fontH+2, ++numGameResourcesLoaded, numGameResources, Color.BLACK, Color.BLACK);
                itemImage[3] = loadImageSync("ball0300.png");
                drawLoadingBar(g, fontW*2, fontH*2+2, playW/2, fontH+2, ++numGameResourcesLoaded, numGameResources, Color.BLACK, Color.BLACK);
                itemImage[4] = loadImageSync("ball0400.png");
                drawLoadingBar(g, fontW*2, fontH*2+2, playW/2, fontH+2, ++numGameResourcesLoaded, numGameResources, Color.BLACK, Color.BLACK);
                itemImage[5] = loadImageSync("ball0500.png");
                drawLoadingBar(g, fontW*2, fontH*2+2, playW/2, fontH+2, ++numGameResourcesLoaded, numGameResources, Color.BLACK, Color.BLACK);
                itemImage[6] = loadImageSync("pow0000.png");
                drawLoadingBar(g, fontW*2, fontH*2+2, playW/2, fontH+2, ++numGameResourcesLoaded, numGameResources, Color.BLACK, Color.BLACK);
                itemImage[7] = loadImageSync("pow0100.png");
                drawLoadingBar(g, fontW*2, fontH*2+2, playW/2, fontH+2, ++numGameResourcesLoaded, numGameResources, Color.BLACK, Color.BLACK);
                itemImage[8] = loadImageSync("pow0200.png");
                drawLoadingBar(g, fontW*2, fontH*2+2, playW/2, fontH+2, ++numGameResourcesLoaded, numGameResources, Color.BLACK, Color.BLACK);
                itemImage[9] = loadImageSync("pow0300.png");
                drawLoadingBar(g, fontW*2, fontH*2+2, playW/2, fontH+2, ++numGameResourcesLoaded, numGameResources, Color.BLACK, Color.BLACK);
                itemImage[10] = loadImageSync("ball0700.png");
                drawLoadingBar(g, fontW*2, fontH*2+2, playW/2, fontH+2, ++numGameResourcesLoaded, numGameResources, Color.BLACK, Color.BLACK);
                hudBgImage = loadImageSync("hudbg.png");
                drawLoadingBar(g, fontW*2, fontH*2+2, playW/2, fontH+2, ++numGameResourcesLoaded, numGameResources, Color.BLACK, Color.BLACK);
                ballEmotionImage[0] = loadImageSync("ballemo0.png");
                drawLoadingBar(g, fontW*2, fontH*2+2, playW/2, fontH+2, ++numGameResourcesLoaded, numGameResources, Color.BLACK, Color.BLACK);
                ballEmotionImage[1] = loadImageSync("ballemo1.png");
                drawLoadingBar(g, fontW*2, fontH*2+2, playW/2, fontH+2, ++numGameResourcesLoaded, numGameResources, Color.BLACK, Color.BLACK);
                ballEmotionImage[2] = loadImageSync("ballemo2.png");
                drawLoadingBar(g, fontW*2, fontH*2+2, playW/2, fontH+2, ++numGameResourcesLoaded, numGameResources, Color.BLACK, Color.BLACK);
                ballEmotionImage[3] = loadImageSync("ballemo3.png");
                drawLoadingBar(g, fontW*2, fontH*2+2, playW/2, fontH+2, ++numGameResourcesLoaded, numGameResources, Color.BLACK, Color.BLACK);
        }

        //load all the images up before we start going
        void loadGameSounds(Graphics g)
        {
                soundAbsorbDot = loadClip("sfx0000.wav");
                drawLoadingBar(g, fontW*2, fontH*2+2, playW/2, fontH+2, ++numGameResourcesLoaded, numGameResources, Color.BLACK, Color.BLACK);
                soundBadDot = loadClip("sfx0001.wav");
                drawLoadingBar(g, fontW*2, fontH*2+2, playW/2, fontH+2, ++numGameResourcesLoaded, numGameResources, Color.BLACK, Color.BLACK);
                soundTimeSlow = loadClip("sfx0003.wav");
                drawLoadingBar(g, fontW*2, fontH*2+2, playW/2, fontH+2, ++numGameResourcesLoaded, numGameResources, Color.BLACK, Color.BLACK);
                soundTimeSpeed = loadClip("sfx0004.wav");
                drawLoadingBar(g, fontW*2, fontH*2+2, playW/2, fontH+2, ++numGameResourcesLoaded, numGameResources, Color.BLACK, Color.BLACK);
                soundPlayerAppear = loadClip("sfx0005.wav");
                drawLoadingBar(g, fontW*2, fontH*2+2, playW/2, fontH+2, ++numGameResourcesLoaded, numGameResources, Color.BLACK, Color.BLACK);
                soundTick = loadClip("sfx0006.wav");
                drawLoadingBar(g, fontW*2, fontH*2+2, playW/2, fontH+2, ++numGameResourcesLoaded, numGameResources, Color.BLACK, Color.BLACK);
                soundItemAppear = loadClip("sfx0007.wav");
                drawLoadingBar(g, fontW*2, fontH*2+2, playW/2, fontH+2, ++numGameResourcesLoaded, numGameResources, Color.BLACK, Color.BLACK);
                soundBomb = loadClip("sfx0008.wav");
                drawLoadingBar(g, fontW*2, fontH*2+2, playW/2, fontH+2, ++numGameResourcesLoaded, numGameResources, Color.BLACK, Color.BLACK);
                soundBombHit = loadClip("sfx0009.wav");
                drawLoadingBar(g, fontW*2, fontH*2+2, playW/2, fontH+2, ++numGameResourcesLoaded, numGameResources, Color.BLACK, Color.BLACK);
                soundExtraCredit = loadClip("sfx0010.wav");
                drawLoadingBar(g, fontW*2, fontH*2+2, playW/2, fontH+2, ++numGameResourcesLoaded, numGameResources, Color.BLACK, Color.BLACK);
                soundSuddenDeath = loadClip("sfx0011.wav");
                drawLoadingBar(g, fontW*2, fontH*2+2, playW/2, fontH+2, ++numGameResourcesLoaded, numGameResources, Color.BLACK, Color.BLACK);
        }

        //load all game images, sounds, etc.
        void loadGameResources(Graphics g)
        {
                loadGameImages(g);
                loadGameSounds(g);
        }

        //set the hiscore stuff up
        void initializeHiScoreStuff()
        {
            	loadHiScores();
                //setDummyScoreboard();
        }

		//load a font from a local file
		Font loadFontFile(String filename, int fH)
		{
			Font ft = null;
			try
			{
				URL fontUrl = null;
				//URL fontUrl = new File("DoctorSoosBold.ttf").toURI().toURL();

				//try{ fontUrl = getClass().getClassLoader().getResource("/DoctorSoosBold.ttf"); } catch(Exception E){ System.out.println("File DoctorSoosBold.ttf not found."); }
				//Font tempFont = Font.createFont(Font.TRUETYPE_FONT, fontUrl.openStream());
				InputStream is = this.getClass().getResourceAsStream(filename);
				Font tempFont = Font.createFont(Font.TRUETYPE_FONT, is);
				if(tempFont == null) System.out.println("error creating tempFont...");
				ft = tempFont.deriveFont(Font.PLAIN, fH);
				if(ft == null) System.out.println("error creating gameFont...");
			}
			catch(Exception e)
			{
				System.out.println("font not loaded...");
			}

			return ft;
		}

		//initialize the configuration
		public void initializeConfig(String filename)
		{
			//tempStr = tempStream.loadData(filename, MAX_SCORES*numDataVars);
			int count = 0;
			boolean localFileExists = true;     //use this to see if we've got a hiscore.txt saved already

			try
			{
				URL fileURL = null;
				BufferedReader bufferedReader = null;
				FileReader fileReader = null;

				// FileReader reads text files in the default encoding.
				try{ fileReader = new FileReader(filename); }
				catch(Exception E)   //if the file can't be read here, that means it doesn't exist yet locally..
				{
					localFileExists = false;
				}
				//FileReader fileReader = new FileReader(fileURL);

				if(localFileExists)
				{
					System.out.println("Config file exists, so loading file for data extraction..");
					bufferedReader = new BufferedReader(fileReader);
					//bufferedReader = new BufferedReader(new InputStreamReader(getClass().getResourceAsStream(filename)));
				}
				else
				{
					System.out.println("Config file doesn't exist, so loading initial config from JAR...");
					loadConfigFile(filename);
					return;
				}

				String line = null;
				while((line = bufferedReader.readLine()) != null)
	  			{
					//check what this line says..
					String[] tempStr = line.split(" ");
					//look for sound setting
					if(tempStr[0] == null) continue;
					if(tempStr[0].equals("sound"))
					{
						int val = Integer.parseInt(tempStr[1]);
						if(val == 0){ soundOn = false; soundMode = 0; System.out.println("Sound disabled"); }
						else if(val == 1){ soundOn = true; soundMode = 1; System.out.println("Sound enabled (mode 1)"); }
						else if(val == 2){ soundOn = true; soundMode = 2; System.out.println("Sound enabled (mode 2)"); }
						else if(val == 3){ soundOn = true; soundMode = 2; System.out.println("Sound enabled (mode 3)"); }
					}
					if(tempStr[0].equals("shadows"))
					{
						int val = Integer.parseInt(tempStr[1]);
						if(val == 0){ shadowsOn = false; System.out.println("Shadows disabled"); }
						else{ shadowsOn = true; System.out.println("Shadows enabled"); }
					}
	  			}

	  			// Always close files.
	  			bufferedReader.close();
			}
			catch(FileNotFoundException ex)
			{
				System.out.println("Unable to open file '" + filename + "'");
			}
			catch(IOException ex)
			{
				System.out.println("Error reading file '" + filename + "'");
			}

		}

		//load the settings configuration file
		public void loadConfigFile(String filename)
		{
			try
			{
				BufferedReader bufferedReader = null;
				FileReader fileReader = null;

				System.out.println("Loading config file '" + filename + "'...");
				// FileReader reads text files in the default encoding.
				//FileReader fileReader = new FileReader(filename);
				// Always wrap FileReader in BufferedReader.
				//BufferedReader bufferedReader = new BufferedReader(fileReader);

				InputStream in = getClass().getResourceAsStream(filename);
				bufferedReader = new BufferedReader(new InputStreamReader(in));

				String line = null;
				while((line = bufferedReader.readLine()) != null)
	  			{
					//check what this line says..
					String[] tempStr = line.split(" ");
					//look for sound setting
					if(tempStr[0] == null) continue;
					if(tempStr[0].equals("sound"))
					{
						int val = Integer.parseInt(tempStr[1]);
						if(val == 0){ soundOn = false; System.out.println("Sound disabled"); }
						else{ soundOn = true; System.out.println("Sound enabled"); }
					}
					if(tempStr[0].equals("shadows"))
					{
						int val = Integer.parseInt(tempStr[1]);
						if(val == 0){ shadowsOn = false; System.out.println("Shadows disabled"); }
						else{ shadowsOn = true; System.out.println("Shadows enabled"); }
					}
	  			}

	  			// Always close files.
	  			bufferedReader.close();
			}
			catch(FileNotFoundException ex)
			{
				System.out.println("Unable to open file '" + filename + "'");
			}
			catch(IOException ex)
  			{
				System.out.println("Error reading file '" + filename + "'");
  			}
		}

        //applet initialization sequence
        boolean initApp(Graphics g)
        {
                //start the average timer..
                gameAverageTimer = new AverageTimer( System.currentTimeMillis() );

				//load the config file..
				initializeConfig("dcFinal.cfg");

                //register the font
                if(!isOnline){
						gameFont = loadFontFile("kongtext.ttf", 36);
                        //gameFont = new Font("kongtext", Font.BOLD, 36);
                        }
                else{
                        gameFont = loadRemoteFont("/dotJava/kongtext.ttf", 36, true);
                        }
				if(gameFont != null)
				{
					System.out.println("Font successfully loaded. Deriving other fonts...");
                	gameSmallFont = gameFont.deriveFont(10.0f).deriveFont(Font.PLAIN);
                	g.setFont(gameSmallFont);
                	g_scBuff.setFont(gameSmallFont);
				}
				else
				{
					System.out.println("Falling back to standard fonts...");
					gameFont = new Font("monospaced", Font.BOLD, 36);
					gameSmallFont = gameFont.deriveFont(10.0f).deriveFont(Font.PLAIN);
				}

                g.drawString("Loading image and sound data..", 0, fontH*2);
                //load game image files
                loadGameResources(g);

                g.drawString("Loading hiscores from server..", 0, fontH*5);
                //set the hiscore-related stuff up
                initializeHiScoreStuff();

                //ah! success!
                return true;
        }

        //keyboard listener stuff
        public void keyPressed(KeyEvent e){
                int k = e.getKeyCode();
                if(gameState == GAMESTATE_READY){
                        if(k == KeyEvent.VK_A || k == KeyEvent.VK_LEFT){
                                if(controlType == 0){
                                        gamePlayer.turnLeft();
                                        }
                                else{
                                        if(!gamePlayer.isDead()) gamePlayer.goLeft();
                                        if(gamePlayer.isAppearing()) gamePlayer.setActive();
                                        }
                                }
                        if(k == KeyEvent.VK_D || k == KeyEvent.VK_RIGHT){
                                if(controlType == 0){
                                        gamePlayer.turnRight();
                                        }
                                else{
                                        if(!gamePlayer.isDead()) gamePlayer.goRight();
                                        if(gamePlayer.isAppearing()) gamePlayer.setActive();
                                        }
                                }
                        if(k == KeyEvent.VK_W || k == KeyEvent.VK_UP){
                                if(controlType == 0){
                                        gamePlayer.goForward();
                                        }
                                else{
                                        if(!gamePlayer.isDead()) gamePlayer.goUp();
                                        if(gamePlayer.isAppearing()) gamePlayer.setActive();
                                        }
                                }
                        if(k == KeyEvent.VK_S || k == KeyEvent.VK_DOWN){
                                if(controlType == 0){
                                        }
                                else{
                                        if(!gamePlayer.isDead()) gamePlayer.goDown();
                                        if(gamePlayer.isAppearing()) gamePlayer.setActive();
                                        }
                                }
                        }
                else if(gameState == GAMESTATE_GAMEOVER){
                        if(gotHiScore && !hiScoreEntryDone){
                                if(e.getKeyCode() == KeyEvent.VK_ENTER){
                                        finishHiScoreEntry();
                                        }
                                }
                        }
                }
        public void keyReleased(KeyEvent e){
                int k = e.getKeyCode();
                if(gameState == GAMESTATE_READY){
                        if(k == KeyEvent.VK_A || k == KeyEvent.VK_S || k == KeyEvent.VK_W || k == KeyEvent.VK_D){
                                gamePlayer.setDir(DIR_NONE);
                                }
                        }
                }
        public void keyTyped(KeyEvent e){
                switch(gameState){
                        case GAMESTATE_GAMEOVER:
                                if(gotHiScore && !hiScoreEntryDone){
                                        //backspace.. erase last letter
                                        if(e.getKeyChar() == (char)8){
                                                if(playerNameString.length() > 0){
                                                        int len = playerNameString.length();
                                                        String str = playerNameString.substring(0, len-1);
                                                        playerNameString = str;
                                                        }
                                                }
                                        else if(e.getKeyCode() == KeyEvent.VK_ENTER){
                                                finishHiScoreEntry();
                                                }
                                        else{
                                                if(playerNameString.length() < maxNameLength){
                                                        playerNameString += e.getKeyChar();
                                                        }
                                                }
                                        }
                                break;
                        default:
                                break;
                        }
                }

        //mouse listener stuff
        public void mousePressed(MouseEvent e)
        {
                switch(gameState){
                        case GAMESTATE_READY:  //fire the rope on click
                                if(controlType == 0){
                                        gamePlayer.fireRope(e.getX(), e.getY());
                                        }

                                break;
                        default:
                                break;
                        }
        }
        public void mouseClicked(MouseEvent e)
        {
                switch(gameState){
                        case GAMESTATE_TITLE:  //start the game on click
                                gameState = GAMESTATE_INITIALIZE;

                                break;
                        case GAMESTATE_GAMEOVER:  //restart the game on click
                                //don't restart if the player isn't done entering his/her name..
                                if(gotHiScore && !hiScoreEntryDone) return;

                                //restart the game..
                                gameState = GAMESTATE_INITIALIZE;
                                screenCleared = false;

                                break;
                        default:
                                break;
                        }
        }

        public void mouseEntered(MouseEvent e){ }
        public void mouseExited(MouseEvent e){ }
        public void mouseReleased(MouseEvent e){ }
        public void mouseDragged(MouseEvent e){ }
        public void mouseMoved(MouseEvent e){ }

        //draw the clock all digital-like
        void clockDisplay(Graphics g, clock co, int x, int y, Color color, int fontSize)
        {
                Font clockFont = new Font("monospaced", Font.BOLD, fontSize);
                g.setColor(color);
                g.drawString("" + intNumberString(co.mins, 2) + ":" + intNumberString(co.secs, 2), x, y);
        }

        //draw the particle queue
        void particleDisplay(Graphics g, particle pa[], int num)
        {
                for(int p = 0; p < num; p++){
                        if(pa[p] != null && !pa[p].isInactive()){
                                pa[p].draw(g, this, gameRectBank);
                                }
                        }
        }

        //handle player drawing stuff
        void playerDisplay(Graphics g, player pl)
        {
				//draw a shadow underneath the player
				//if(shadowsOn)
				//{
					//g.setColor(new Color(0.0f, 0.0f, 0.0f, 0.2f));
					//g.fillOval((int)pl.pos.x+SHADOW_OFFSET, (int)pl.pos.y+SHADOW_OFFSET, pl.w, pl.h);
					//addShadow((int)pl.pos.x+SHADOW_OFFSET, (int)pl.pos.y+SHADOW_OFFSET, pl.w, pl.h);
					//addDirtyRect((int)pl.pos.x+SHADOW_OFFSET-1, (int)pl.pos.y+SHADOW_OFFSET-1, pl.w+SHADOW_OFFSET+1, pl.h+SHADOW_OFFSET+1);
				//}
				g.drawImage(itemImage[pl.color], (int)pl.pos.x, (int)pl.pos.y, this);
                //draw the eyes
                int eyeX = (int)pl.pos.x+pl.w/2, eyeY = (int)pl.pos.y+pl.h/2;
                g.setColor(Color.BLACK);
                if(pl.isDead()){
                        g.fillRect(eyeX+(int)pl.eyePos[0].x, eyeY+(int)pl.eyePos[0].y, pl.eyeW, pl.eyeH/2);
                        g.fillRect(eyeX+(int)pl.eyePos[1].x, eyeY+(int)pl.eyePos[1].y, pl.eyeW, pl.eyeH/2);
                        }
                else{
                        g.fillRect(eyeX+(int)pl.eyePos[0].x, eyeY+(int)pl.eyePos[0].y, pl.eyeW, pl.eyeH);
                        g.fillRect(eyeX+(int)pl.eyePos[1].x, eyeY+(int)pl.eyePos[1].y, pl.eyeW, pl.eyeH);
                        }
				//int mult = (shadowsOn ? 1 : 0);
                //addDirtyRect((int)pl.pos.x-1, (int)pl.pos.y-1, pl.w+2+SHADOW_OFFSET*mult, pl.h+2+SHADOW_OFFSET*mult);

                //draw the rope..
                if(pl.ropeActive > 0){
                        int ropeEndX, ropeEndY;
                        ropeEndX = (int)(pl.ropePos.x+pl.ropeLength*(float)Math.cos(pl.ropeAngle));
                        ropeEndY = (int)(pl.ropePos.y+pl.ropeLength*(float)Math.sin(pl.ropeAngle));
                        g.setColor(Color.WHITE);
                        g.drawLine((int)pl.ropePos.x, (int)pl.ropePos.y, ropeEndX, ropeEndY);

                        //draw the dirty rect..
                        int x, y, w, h;
                        if(ropeEndX < (int)pl.ropePos.x){
                                x = ropeEndX;
                                w = (int)pl.ropePos.x-x;
                                }
                        else{
                                x = (int)pl.ropePos.x;
                                w = ropeEndX-x;
                                }
                        if(ropeEndY < (int)pl.ropePos.y){
                                y = ropeEndY;
                                h = (int)pl.ropePos.y-y;
                                }
                        else{
                                y = (int)pl.ropePos.y;
                                h = ropeEndY-y;
                                }
                        //addDirtyRect(x-2, y-2, w+6, h+6);
                        }
        }

        //handle drawing the items
        void itemDisplay(Graphics g, item it[], int num)
        {
                for(int i = 0; i < num; i++){
                        if(it[i] != null && !it[i].isInactive()){
								//draw the shadow
								//if(shadowsOn)
								//{
									//g.setColor(new Color(0.0f, 0.0f, 0.0f, 0.2f));
									//g.fillOval((int)it[i].pos.x+SHADOW_OFFSET, (int)it[i].pos.y+SHADOW_OFFSET, it[i].w, it[i].h);
									//addShadow((int)it[i].pos.x+SHADOW_OFFSET, (int)it[i].pos.y+SHADOW_OFFSET, it[i].w, it[i].h);
									//addDirtyRect((int)it[i].pos.x+SHADOW_OFFSET-1, (int)it[i].pos.y+SHADOW_OFFSET-1, it[i].w+SHADOW_OFFSET+1, it[i].h+SHADOW_OFFSET+1);
								//}
								//draw the item
								g.drawImage(itemImage[it[i].color], (int)it[i].pos.x, (int)it[i].pos.y, this);

								int mult = (shadowsOn ? 1 : 0);
								//addDirtyRect((int)pl.pos.x-1, (int)pl.pos.y-1, pl.w+2+SHADOW_OFFSET*mult, pl.h+2+SHADOW_OFFSET*mult);
//            					addDirtyRect((int)it[i].pos.x-1, (int)it[i].pos.y-1, it[i].w+2+SHADOW_OFFSET*mult, it[i].h+2+SHADOW_OFFSET*mult);
                                }
                        }
        }

        //draw the grid overlay (if we use it?)
        void gridDisplay(Graphics g)
        {
        }

        //draw the scrolling backdrop
        void backgroundDisplay(Graphics g)
        {
                //draw the play area
                //g.setColor(clearColor);
                //g.fillRect((int)playFieldPos.x, (int)playFieldPos.y, playW, playH);
                //gridDisplay(g);

                //draw the black border around the play area
                //g.setColor(Color.black);
                //g.drawRect((int)playFieldPos.x, (int)playFieldPos.y, playW, playH);
        }

        //add a rect to the dirty rect queue
        void addDirtyRect(int x, int y, int w, int h)
        {
                gameRectBank.addRect(x, y, w, h);
        }

        //clear the dirty rect queue
        void clearDirtyRects(Graphics g)
        {
                gameRectBank.clear(g, this, clearColor);
        }

		//clear the shadows
		void clearShadows(Graphics g)
		{
				gameShadowBank.clear(g, this, clearColor);
		}

		//draw the shadows
        void drawShadows(Graphics g)
        {
				//draw the player's shadow
				g.setColor(new Color((int)(clearColor.getRed()*0.8f), (int)(clearColor.getGreen()*0.8f), (int)(clearColor.getBlue()*0.8f)));
				g.fillOval((int)gamePlayer.pos.x+SHADOW_OFFSET, (int)gamePlayer.pos.y+SHADOW_OFFSET, gamePlayer.w, gamePlayer.h);

				//draw the item shadows
				for(int i = 0; i < numItems+numBadItems; i++)
				{
					if(gameItem[i] == null) continue;
					if(!gameItem[i].isInactive()) g.fillOval((int)gameItem[i].pos.x+SHADOW_OFFSET, (int)gameItem[i].pos.y+SHADOW_OFFSET, gameItem[i].w, gameItem[i].h);
				}
                //gameShadowBank.clearAsOval(g, this, new Color((int)(clearColor.getRed()*0.8f), (int)(clearColor.getGreen()*0.8f), (int)(clearColor.getBlue()*0.8f)));
        }

		//add a shadow to the shadow queue...
		void addShadow(int x, int y, int w, int h)
		{
				gameShadowBank.addRect(x, y, w, h);
		}

        Image getCurEmotionImage()
        {
                if(gamePlayer.isDead()){
                        return ballEmotionImage[1];
                        }
                else if(gamePlayer.isSlow()){
                        return ballEmotionImage[2];
                        }
                else if(gamePlayer.isFast()){
                        return ballEmotionImage[3];
                        }
                return ballEmotionImage[0];
        }

        //draw the hud/status stuff
        void hudDisplay(Graphics g)
        {
                //draw the hud background
                g.drawImage(hudBgImage, playW, 0, this);
                //draw the emotion and timer stuff
                g.setColor(gameColor(gamePlayer.color));
                g.fillOval((int)(hudPos.x+hudEmotionPos.x-hudEmotionRadius), (int)(hudPos.y+hudEmotionPos.y-hudEmotionRadius), hudEmotionRadius*2, hudEmotionRadius*2);
                g.setColor(Color.BLACK);
                g.drawOval((int)(hudPos.x+hudEmotionPos.x-hudEmotionRadius), (int)(hudPos.y+hudEmotionPos.y-hudEmotionRadius), hudEmotionRadius*2, hudEmotionRadius*2);
                //g_scBuff.drawOval((int)(hudPos.x+hudEmotionPos.x-hudEmotionRadius-1), (int)(hudPos.y+hudEmotionPos.y-hudEmotionRadius-1), (hudEmotionRadius+1)*2, (hudEmotionRadius+1)*2);
                g.drawImage(getCurEmotionImage(), (int)(hudPos.x+hudEmotionPos.x-hudEmotionRadius), (int)(hudPos.y+hudEmotionPos.y-hudEmotionRadius), this);

                if(gamePlayer.powerClock != null && gamePlayer.powerClock.secs >= 0 && gameState != GAMESTATE_GAMEOVER){
                        g.setFont(gameFont);
                        g.setColor(new Color(255, 255, 255, 192));
                        g.drawString(""+gamePlayer.getPowerTimeRemaining(), (int)(hudPos.x+hudEmotionPos.x-18), (int)(hudPos.y+hudEmotionPos.y+10));
                        }

                //draw the scores, etc.
                g.setFont(gameSmallFont);
                g.setColor(new Color(0, 0, 0, 255));
                g.drawString(longNumberString(gamePlayer.score,6), (int)(hudPos.x+hudScorePos.x), (int)(hudPos.y+hudScorePos.y));
                g.drawString(longNumberString(curHighestScore(),6), (int)(hudPos.x+hudHiScorePos.x), (int)(hudPos.y+hudHiScorePos.y));
                g.drawString(longNumberString(curLevel, 2), (int)(hudPos.x+hudLevelPos.x), (int)(hudPos.y+hudLevelPos.y));
                g.drawString(longNumberString(gamePlayer.curStreak, 3), (int)(hudPos.x+hudStreakPos.x), (int)(hudPos.y+hudStreakPos.y));
                g.drawString(longNumberString(gamePlayer.bestStreak, 3), (int)(hudPos.x+hudBestStreakPos.x), (int)(hudPos.y+hudBestStreakPos.y));

                //draw the credits counter
                for(int i = 0; i < gamePlayer.credits; i++){
                        int x = (int)(hudPos.x+hudCreditsPos.x)+i*(gamePlayer.w/2);
                        int y = (int)(hudPos.y+hudCreditsPos.y);
                        g.drawImage(itemImage[gamePlayer.color], x, y, this);
                        int eyeX = x+gamePlayer.w/2, eyeY = y+gamePlayer.h/2;
                        g.setColor(Color.BLACK);
                        g.fillRect(eyeX-4, eyeY-1, player.DEFAULT_EYE_SIZE, player.DEFAULT_EYE_SIZE);
                        g.fillRect(eyeX+2, eyeY-1, player.DEFAULT_EYE_SIZE, player.DEFAULT_EYE_SIZE);
                        }
                //scale the extra credit up for a moment to accentuate it
                if(creditsScale >= 0){
                        g.drawImage(itemImage[gamePlayer.color], (int)(hudPos.x+hudCreditsPos.x)+(gamePlayer.credits-1)*(gamePlayer.w/2)-creditsScale/4, (int)(hudPos.y+hudCreditsPos.y)-creditsScale/4, itemImage[gamePlayer.color].getWidth(this)+creditsScale/2, itemImage[gamePlayer.color].getHeight(this)+creditsScale/2, this);
                        if(creditsScale++ >= 10) creditsScale = -1;
                        }
        }

        //draw the hud/status stuff
        void hudEmptyDisplay(Graphics g)
        {
                //draw the hud background
                g.drawImage(hudBgImage, playW, 0, this);
                //draw the emotion and timer stuff

                //draw the scores, etc.
                g.setFont(gameSmallFont);
                g.setColor(new Color(0, 0, 0, 255));
                g.drawString(longNumberString(0, 6), (int)(hudPos.x+hudScorePos.x), (int)(hudPos.y+hudScorePos.y));
                g.drawString(longNumberString(curHighestScore(), 6), (int)(hudPos.x+hudHiScorePos.x), (int)(hudPos.y+hudHiScorePos.y));
                g.drawString(longNumberString(0, 2), (int)(hudPos.x+hudLevelPos.x), (int)(hudPos.y+hudLevelPos.y));
                g.drawString(longNumberString(0, 3), (int)(hudPos.x+hudStreakPos.x), (int)(hudPos.y+hudStreakPos.y));
                g.drawString(longNumberString(0, 3), (int)(hudPos.x+hudBestStreakPos.x), (int)(hudPos.y+hudBestStreakPos.y));
        }

        //draw the title screen
        void titleDisplay(Graphics g)
        {
                //draw a rotating circle of spheres..
                int numTitleItems = 16;
                int cx = playW/2, cy = playH/2;
                float ang = 0.0f, da = (float)(Math.PI*2.0f)/numTitleItems;
                //center circle of dots
                for(int i = 0; i < numTitleItems; i++, ang += da){
                        g.drawImage(itemImage[i%6], (int)(cx+titleRad*(float)Math.cos(titleAngle+ang)), (int)(cy+titleRad*(float)Math.sin(titleAngle+ang)), this);
                        }

                //draw the sine wave(s)
                int numTitleSinItems = playW/ballSize;
                float ang2 = 0.0f, da2 = (float)(Math.PI*2.0f)/numTitleSinItems;
                int y1 = cy-140, y2 = cy+140;
                float rad = 20.0f;
                for(int i = 0; i < numTitleSinItems; i++, ang2 += da2){
                        g.drawImage(itemImage[i%6], i*ballSize, (int)(y1+rad*(float)Math.sin(titleSinAngle+ang2)), this);
                        g.drawImage(itemImage[i%6], i*ballSize, (int)(y2+rad*(float)Math.cos(titleSinAngle+ang2)), this);
                        }
                g.setColor(new Color(80, 80, 80, 255));
                g.drawString(versionString, playW-210, playH-1);
                gameStartDisplay(g);
        }

        //draw the hiscore listing box
        void hiScoreListingDisplay(Graphics g)
        {
        }

        //tells if the hiscores list is currently showing
        boolean hiScoresListShowing()
        {
                return !gotHiScore && hiScoreEntryDone;
        }

        //draw the hiscore box background
        void hiScoreBgDisplay(Graphics g)
        {
                g.setColor(new Color(157, 182, 204, 185));
                g.fillRect(10, playH/2-100, playW-20, 180);
                g.setColor(Color.BLACK);
                g.drawRect(10, playH/2-100, playW-20, 180);
        }

        //draw the hiscore entry box
        void hiScoreEntryDisplay(Graphics g)
        {
                hiScoreBgDisplay(g);
                g.setFont(gameSmallFont);
                g.setColor(Color.BLACK);
                g.drawString("You got a high score!", playW/2-100, playH/2-85);
                g.setColor(new Color(0, 0, 0, 20));
                g.drawString("You got a high score!", playW/2-100+1, playH/2-85+1);
                g.setColor(new Color(255, 255, 255, 80));
                g.fillRect(playW/2-(maxNameLength*smallFontW)/2, playH/2-smallFontH-2, maxNameLength*smallFontW, smallFontH+4);
                g.setColor(Color.BLACK);
                g.drawString(playerNameString, playW/2-(maxNameLength*smallFontW)/2, playH/2);
        }

        //draw the hiscore listing
        void hiScoreDisplay(Graphics g)
        {
                hiScoreBgDisplay(g);
                g.setFont(gameSmallFont);
                g.setColor(new Color(0, 0, 0, 190));
                g.drawString("Top Scores", playW/2-52, playH/2-85);
                g.drawString("Name", 32+smallFontW, playH/2-70);
                g.drawString("Score", 32+smallFontW*maxNameLength+smallFontW, playH/2-70);
                g.drawString("Strk", 32+smallFontW*27+smallFontW, playH/2-70);
                g.drawString("Lv", 32+smallFontW*32+smallFontW, playH/2-70);
                //for(int i = 0; i < (gameHiScoreBank.numScores[gameMode] < 10 ? gameHiScoreBank.numScores[gameMode] : 10); i++){
                for(int i = hiScoreStart; i < (gameHiScoreBank.numScores[gameMode] < 10 ? gameHiScoreBank.numScores[gameMode] : hiScoreStart+numHiScoresShown); i++){
                        g.setColor(new Color(0, 0, 0, 140));
                        g.drawString(longNumberStringEmptySpaces(i+1, 2), 32-fontW*2, playH/2-70+(fontH+2)*(i-hiScoreStart+1)+fontH);
                        g.setColor(Color.BLACK);
                        g.drawString(gameHiScoreBank.score[gameMode][i].name, 32+smallFontW, playH/2-70+(fontH+2)*(i-hiScoreStart+1)+fontH);
                        g.drawString(longNumberString(gameHiScoreBank.score[gameMode][i].score, 6), 32+smallFontW*maxNameLength+smallFontW, playH/2-70+(fontH+2)*(i-hiScoreStart+1)+fontH);
                        g.drawString(longNumberString(gameHiScoreBank.score[gameMode][i].streak, 3), 32+smallFontW*27+smallFontW, playH/2-70+(fontH+2)*(i-hiScoreStart+1)+fontH);
                        g.drawString(longNumberString(gameHiScoreBank.score[gameMode][i].level, 2), 32+smallFontW*32+smallFontW, playH/2-70+(fontH+2)*(i-hiScoreStart+1)+fontH);
                        }
        }

        //draw the "click anywhere" text before initializing gameplay
        void gameStartDisplay(Graphics g)
        {
                hiScoreDisplay(g);
                g.setFont(gameSmallFont);
                g.setColor(new Color(20, 20, 20, 255));
                g.drawString("Click anywhere to start", APP_W/2-160+1, APP_H/2+120+1);
                g.setColor(Color.WHITE);
                g.drawString("Click anywhere to start", APP_W/2-160, APP_H/2+120);
        }

        //draw the game over screen
        void gameOverDisplay(Graphics g)
        {
                g.setFont(gameFont);
                g.setColor(new Color(0, 0, 0, 235));
                g.drawString("Game Over", playW/2-165+3, playH/2-110+3);
                g.setColor(new Color(255, 255, 255, 255));
                g.drawString("Game Over", playW/2-165, playH/2-110);
                if(gotHiScore && !hiScoreEntryDone){
                        hiScoreEntryDisplay(g);
                        }
                else{
                        gameStartDisplay(g);
                        }
        }

		//draw the playfield backdrop
		void playfieldDisplay(Graphics g)
		{
				g.setColor(clearColor);
				g.fillRect(0, 0, playW, playH);
		}

        //display method (run() calls this each frame)
        void paintApp(Graphics g)
        {
                backgroundDisplay(g_scBuff);

                switch(gameState){
                        case GAMESTATE_TITLE: //draw the title screen
                                //g_scBuff.setColor(clearColor);
                                //g_scBuff.fillRect(0, 0, playW, playH);
								playfieldDisplay(g_scBuff);
                                titleDisplay(g_scBuff);
                                hudEmptyDisplay(g_scBuff);

                                break;
                        case GAMESTATE_INITIALIZE:
                                //g_scBuff.setColor(clearColor);
                                //g_scBuff.fillRect(0, 0, playW, playH);
								playfieldDisplay(g_scBuff);
                                break;
                        case GAMESTATE_LEVEL_INITIALIZE:
                                //g_scBuff.setColor(clearColor);
                                //g_scBuff.fillRect(0, 0, playW, playH);
								playfieldDisplay(g_scBuff);
								break;
                        case GAMESTATE_READY:
                                //if(!screenCleared){
                                //        g_scBuff.setColor(clearColor);
                                //        g_scBuff.fillRect(0, 0, playW, playH);
                                //        screenCleared = true;
                                //        }
								playfieldDisplay(g_scBuff);
                                //clearDirtyRects(g_scBuff);
								if(shadowsOn) drawShadows(g_scBuff);
                                itemDisplay(g_scBuff, gameItem, MAX_GAME_ITEMS);
                                playerDisplay(g_scBuff, gamePlayer);
                                particleDisplay(g_scBuff, gameParticle, MAX_GAME_PARTICLES);
                                //draw the status/hud, etc.
                                hudDisplay(g_scBuff);

                                break;
                        case GAMESTATE_GAMEOVER: //draw the game over screen
								playfieldDisplay(g_scBuff);
                                //clearDirtyRects(g_scBuff);
								//clearShadows(g_scBuff);
								if(shadowsOn) drawShadows(g_scBuff);
                                itemDisplay(g_scBuff, gameItem, MAX_GAME_ITEMS);
                                playerDisplay(g_scBuff, gamePlayer);
                                gameOverDisplay(g_scBuff);

                                break;
                        default:
                                break;
                        }

                //draw the screen buffer to screen
                g.drawImage(img_scBuff, 0, 0, this);
        }

        //check the player's score for milestones
        void checkPlayerScore(player pl)
        {
                if(pl.score > curHighestScore()){
                        setCurHighestScore(pl.score);
                        }
                if(pl.score > extraCreditScore*extraCreditMultiplier){
                        pl.addCredit();
                        extraCreditMultiplier++;
                        //spawn the "1up" trail..
                        //spawnParticle(hudCreditsPos, new vertex(0, -0.5f, 0), "1up", gameSmallFont, new Color(255, 255, 255, 150), 20, 20, particle.SHAPE_TEXT, 1, 50, -20, 150);
                        //make the latest credit scale up
                        creditsScale = 0;
                        playExtraCreditSound();
                        }
        }

        //handle player logic routines
        void playerLogic(player pl)
        {
                pl.move();
                keepPlayerInBounds(pl);
                if(pl.ropeActive > 0){
                        pl.moveRope();
                        }
                if(pl.powerupTimerActive()){
                        int result = pl.handlePowerUpTimer();
                        switch(result){
                                case 0:
                                        playTimeSlowSound();
                                        break;
                                case 1:
                                        changeItemSpeed(curItemSpeedChange);
                                        curItemSpeedChange = 1.0f;
                                        playTimeSpeedSound();
                                        break;
                                case 4:
                                        //spawn some ghosting trails to give the appearance of motion blur
                                        spawnParticle(pl.getCenterPos(), new vertex(), gameColor(pl.color), pl.w/2, pl.h/2, 0, 0, pl.w*2, -20, 80);
                                        break;
                                default:
                                        break;
                                }
                        if(pl.powerupTimerTicked()){
                                playTickSound();
                                pl.unTickPowerupTimer();
                                }
                        }
                if(pl.isInactive()){
                        int col = pl.color;
                        pl.pos = getPlayerStartingPos();
                        pl.walkSpeed = player.DEFAULT_WALK_SPEED;
                        pl.mode = pl.MODE_ACTIVE;
                        pl.setSlow(3);
                        changeItemSpeed(0.25f);
                        curItemSpeedChange = 4.0f;
                        //put a particle here to point out the player's starting pos
                        spawnPlayerAppearanceParticles();
                        }
        }

        //wrap the item around the boundaries if it goes outside
        void keepItemInBounds(item it)
        {
                if(it.pos.x < 0 || it.pos.x+it.w > playW){
                        it.bounceHorizontal();
                        //playDotBounceSound();
                        }
                if(it.pos.y < 0 || it.pos.y+it.h > playH){
                        it.bounceVertical();
                        //playDotBounceSound();
                        }
        }
        //wrap the player around the boundaries if it goes outside
        void keepPlayerInBounds(player pl)
        {
                if(pl.pos.x < 0){
                        pl.goRight();
                        //playDotBounceSound();
                        }
                else if(pl.pos.x+pl.w > playW){
                        pl.goLeft();
                        //playDotBounceSound();
                        }
                if(pl.pos.y < 0){
                        pl.goDown();
                        //playDotBounceSound();
                        }
                else if(pl.pos.y+pl.h > playH){
                        pl.goUp();
                        //playDotBounceSound();
                        }
        }

        //set a random item on the board to this color
        void setRandomItemToColor(int color)
        {
                //int m = numItems/10;
                //only color a new item if we hit a certain streak point, or if there is only one item of this color remaining on the board
                //if((gamePlayer.curStreak%m) != 0 && numItemsColored[color] > 0) return;
                //System.out.println("m: " + m + ", streak%m: " + gamePlayer.curStreak%m + ", #items: " + numItemsColored[color]);

                for(int i = 0; i < numItems; i++){
                        if(gameItem[i] != null && !gameItem[i].isInactive() && !gameItem[i].isPowerup() && gameItem[i].color != color){
                                gameItem[i].color = color;
                                numItemsColored[color]++;
                                spawnParticle(gameItem[i].getCenterPos(), new vertex(), gameColor(color), gameItem[i].w, gameItem[i].h, 0, 1, gamePlayer.w*8, -20, 255);
                                return;
                                }
                        }
                /*
                int randSlot = (int)((float)Math.random()*numItems);
                while(gameItem[randSlot] == null || gameItem[randSlot].isInactive() || gameItem[randSlot].isPowerup()){
                        randSlot = (int)((float)Math.random()*numItems);
                        }
                gameItem[randSlot].color = color;
                spawnParticle(gameItem[randSlot].getCenterPos(), new vertex(), gameColor(color), gameItem[randSlot].w, gameItem[randSlot].h, 0, 1, gamePlayer.w*8, -20, 255);
                */
        }

        //transition to the next level
        void startLevelTransition()
        {
                curStreak = gamePlayer.curStreak;
                bestStreak = gamePlayer.bestStreak;
                credits = gamePlayer.credits;
                score = gamePlayer.score;
				gameState = GAMESTATE_LEVEL_INITIALIZE;
                curLevel++;

				//screenCleared = false;    //make sure we clear the screen...
        }

        //transition to the game over screen
        void startGameOverTransition()
        {
                extraCreditMultiplier = 1;
                score = 0;
                gameState = GAMESTATE_GAMEOVER_BEGIN;
                curStreak = 0;
                bestStreak = 0;

				//screenCleared = false;    //make sure we clear the screen...
        }

        //slow/speed up all the items
        void changeItemSpeed(float spd)
        {
                for(int i = 0; i < MAX_GAME_ITEMS; i++){
                        if(gameItem[i] != null && !gameItem[i].isInactive() && !gameItem[i].isPowerup()){
                                //half the speeds
                                gameItem[i].vel.x *= spd;
                                gameItem[i].vel.y *= spd;
                                }
                        }
        }

        //check for reactions between the particles and this item
        void handleItemParticleInteraction(item it, particle pa[], int num)
        {
                for(int i = 0; i < num; i++){
                        if(pa[i] != null && !it.isPowerup() && !it.isBad() && it.color != pa[i].iColor && !pa[i].isInactive() && pa[i].isHittable()){
                                if(it.getCenterPos().circleCollision(pa[i].pos, it.w/2, pa[i].hRad)){
                                        switch(pa[i].shape){
                                                default:
                                                        it.color = pa[i].iColor;
                                                        numItemsColored[it.color]++;
                                                        spawnParticle(it.getCenterPos(), new vertex(), gameColor(it.color), it.w, it.h, 0, 1, it.w*8, -20, 255);
                                                        playBombHitSound();
                                                        break;
                                                }
                                        }
                                }
                        }
        }

        //check for reactions between the player and this item
        void handleItemPlayerInteraction(item it, player pl)
        {
                if(it.getCenterPos().circleCollision(pl.getCenterPos(), it.w/2, pl.w/2)){
                        if(!pl.isDead() && it.color == pl.color){
                                pl.absorbItem(it);
                                playDotAbsorbSound();
                                //check for a high score
                                checkPlayerScore(pl);

                                //decrement the color count for this item's color
                                numItemsColored[it.color]--;

                                //spawn some fancified debris..
                                spawnParticle(it.getCenterPos(), new vertex(), gameColor(it.color), it.w, it.h, 0, 1, it.w*8, -20, 255);
                                //spawn an item of the current color, so we don't get stuck with no items to bang into
                                if(pl.curNumItems < numItems){
                                        setRandomItemToColor(it.color);
                                        if(numItems-pl.curNumItems == suddenDeathItemCount()){
                                                changeItemSpeed(2.0f);
                                                playSuddenDeathSound();
                                                }
                                        }
                                else{
                                        pl.addPoints(levelUpScore());
                                        checkPlayerScore(pl);
                                        startLevelTransition();
                                        }
                                }
                        else if(!pl.isDead()){
                                if(it.isPowerup()){
                                        int result;
                                        result = pl.acquirePowerupItem(it);

                                        spawnParticle(it.getCenterPos(), new vertex(), Color.white, it.w, it.h, particle.SHAPE_RECT, 1, it.w*8, -20, 180);
                                        switch(result){
                                                case -1:
                                                        playTimeSlowSound();
                                                        break;
                                                case 0:
                                                        playTimeSpeedSound();
                                                        break;
                                                case 1:
                                                        changeItemSpeed(0.25f);
                                                        curItemSpeedChange = 4.0f;
                                                        playTimeSlowSound();
                                                        break;
                                                case 3:    //bomb powerup
                                                        spawnParticle(it.getCenterPos(), new vertex(), gameColor(pl.color), pl.color, it.w, it.h, particle.SHAPE_BOMB, 2, it.w*4, 10, 50);
                                                        playBombSound();
                                                        break;
                                                case 5:
                                                        changeItemSpeed(curItemSpeedChange);
                                                        curItemSpeedChange = 1.0f;
                                                        playTimeSpeedSound();
                                                        break;
                                                default:
                                                        break;
                                                }
                                        if(!pl.isSlow() && curItemSpeedChange > 1.0f){
                                                changeItemSpeed(curItemSpeedChange);
                                                curItemSpeedChange = 1.0f;
                                                }
                                        //check for a high score
                                        checkPlayerScore(pl);
                                        }
                                else{
                                        int randNo = (int)(Math.random()*4)+6;
                                        float ang = (float)it.getCenterPos().angleBetween(pl.getCenterPos());
                                        float x = pl.getCenterPos().x+pl.w*(float)Math.cos(ang);
                                        float y = pl.getCenterPos().y+pl.h*(float)Math.sin(ang);
                                        for(int i = 0; i < randNo; i++){
                                                int randSize = (int)(Math.random()*3)+3;
                                                spawnParticle(new vertex(x+getRandomNegativity()*(float)Math.random()*4.0f, y+getRandomNegativity()*(float)Math.random()*4.0f), getRandomVelocity(1.5f, 1.5f), gameColor(it.color), randSize, randSize, particle.SHAPE_RECT_FILLED, 0, pl.w*8, -18, 128);
                                                }
                                        int hitResult = pl.getHitByItem(it);
                                        playBadDotSound();
                                        if(hitResult == 1){
                                                startGameOverTransition();
                                                }
                                        else if(hitResult == 2){
                                                changeItemSpeed(curItemSpeedChange);
                                                curItemSpeedChange = 1.0f;
                                                }
                                        }
                                }
                        }
        }

        //handle all item-related logic..
        void itemLogic(item it[], int num)
        {
                for(int i = 0; i < num; i++){
                        if(it[i] != null && !it[i].isInactive()){
                                it[i].move();
                                keepItemInBounds(it[i]);
                                handleItemPlayerInteraction(it[i], gamePlayer);
                                handleItemParticleInteraction(it[i], gameParticle, MAX_GAME_PARTICLES);
                                }
                        }
        }

        //handle particle logic stuff..
        void particleLogic(particle pa[], int num)
        {
                for(int p = 0; p < num; p++){
                        if(pa[p] != null && !pa[p].isInactive()){
                                pa[p].logic();
                                }
                        }
        }

        //handle the title screen stuff
        void titleLogic()
        {
                titleRad += titleDRad;
                if(titleRad > 100.0f || titleRad < 40.0f){
                        titleDRad *= -1;
                        titleRad += titleDRad;
                        }
                titleAngle = (float)angleMod(titleAngle+titleDAngle);
                titleSinAngle = (float)angleMod(titleSinAngle+titleDSinAngle);
        }

        //handle the hiscore listing screen stuff
        void hiScoreDisplayLogic()
        {
                if(hiScoreScrolling == 0){
                        hiScoreScrollCount++;
                        if(hiScoreScrollCount >= hiScoreStartSpeed){
                                //start scrolling after a specified initial interval (so we see the best scores longest..)
                                hiScoreScrolling = 1;
                                hiScoreScrollDown = true;
                                System.out.println("start scrolling scores..");
                                }
                        }
                else if(hiScoreScrolling == 1){
                        if(hiScoreScrollDown){
                                hiScoreScrollCount++;
                                if(hiScoreScrollCount >= hiScoreScrollSpeed){
                                        hiScoreStart++;
                                        System.out.println("showing scores "+hiScoreStart+" to "+(hiScoreStart+numHiScoresShown));
                                        if(hiScoreStart+numHiScoresShown >= gameHiScoreBank.numScores[gameMode]){
                                                System.out.println("start scrolling up..");
                                                //hiScoreScrollDown = false;
                                                hiScoreScrolling = 2;
                                                }
                                        hiScoreScrollCount = 0;
                                        }
                                }
                        }
                else if(hiScoreScrolling == 2){
                        if(hiScoreScrollDown){
                                hiScoreScrollCount++;
                                if(hiScoreScrollCount >= hiScoreStartSpeed/2){
                                        hiScoreScrolling = 3;
                                        hiScoreScrollDown = false;
                                        hiScoreScrollCount = 0;
                                        }
                                }
                        }
                else{
                        if(!hiScoreScrollDown){
                                hiScoreScrollCount++;
                                if(hiScoreScrollCount >= hiScoreScrollSpeed){
                                        hiScoreStart--;
                                        if(hiScoreStart <= 0){
                                                System.out.println("restart scrolling..");
                                                hiScoreScrollDown = true;
                                                hiScoreScrolling = 0;
                                                }
                                        hiScoreScrollCount = 0;
                                        }
                                }
                        }
        }

        //handle the game over screen stuff
        void gameOverLogic()
        {
        }

        //add the player's score/data to the hiscore bank
        void addNewHiScore()
        {
                gameHiScoreBank.addNewScore(curScoringMode, gameHiScoreBank.SORT_BYSCORE, playerNameString, gamePlayer.score, gamePlayer.bestStreak, curLevel);
                gameHiScoreBank.sort(curScoringMode, gameHiScoreBank.SORT_BYSCORE);
                saveHiScores();
        }

        //hiscore name entry completed, now let's finish up
        void finishHiScoreEntry()
        {
                hiScoreEntryDone = true;
                gotHiScore = false;
                addNewHiScore();
        }

        //check for collision between this circle and any item
        boolean circleItemCollision(vertex coords, int sz)
        {
                //for(int i = 0; i < numItems; i++){
                for(int i = 0; i < numItems+numBadItems; i++){
                        if(gameItem[i] != null && !gameItem[i].isInactive()){
                                if(coords.circleCollision(gameItem[i].getCenterPos(), sz, gameItem[i].w)){
                                        return true;
                                        }
                                }
                        }
                return false;
        }

        //get a random starting place for the player
        vertex getPlayerStartingPos()
        {
                float x = (float)Math.random()*(playW-ballSize), y = (float)Math.random()*(playH-ballSize);
                vertex tempV = new vertex(x+ballSize/2, y+ballSize/2);
                while(circleItemCollision(tempV, ballSize)){
                        x = (float)Math.random()*(playW-ballSize);
                        y = (float)Math.random()*(playH-ballSize);
                        tempV = new vertex(x+ballSize/2, y+ballSize/2);
                        }
                return new vertex(x, y);
                //return new vertex((float)Math.random()*(playW-ballSize), (float)Math.random()*(playH-ballSize));
        }

        //get the starting color for the player
        int getPlayerStartingColor()
        {
                int randItemSlot = (int)(Math.random()*numItems);
                while(gameItem[randItemSlot].isPowerup()){
                        randItemSlot = (int)(Math.random()*numItems);
                        }
                return gameItem[randItemSlot].color;
        }

        //initialize all the timers we're working with
        void initializeTimers()
        {
                //set the game clock up
                gameClock.reset();
        }

        //initialize the players
        void initializePlayers()
        {
                gamePlayer = new player(getPlayerStartingPos(), new vertex(0, 0), getPlayerStartingColor(), ballSize, ballSize, playerNameString);

                gamePlayer.curStreak = curStreak;
                gamePlayer.bestStreak = bestStreak;
                gamePlayer.credits = credits;
                gamePlayer.score = score;
                //put a particle here to point out the player's starting pos
                //spawnParticle(gamePlayer.getCenterPos(), new vertex(), gameColor(gamePlayer.color), gamePlayer.w/2, gamePlayer.h/2, 0, 1, gamePlayer.w*8, -20, 255);
                gamePlayer.setSlow(3);
                changeItemSpeed(0.25f);
                curItemSpeedChange = 4.0f;
                spawnPlayerAppearanceParticles();
        }

        //initialize the playfield stuff
        void initializePlayfield()
        {
                //darken the background color until we hit black..
                int shade = clearColor.getRed();
                shade -= 20;
                if(shade < 0) shade = 0;
                clearColor = new Color(shade, shade, shade, 255);
                g_scBuff.setColor(clearColor);
                g_scBuff.fillRect(0, 0, playW, playH);
        }

        //find an open/inactive particle slot
        int getOpenParticleSlot()
        {
                for(int i = 0; i < MAX_GAME_PARTICLES; i++){
                        if(gameParticle[i] == null || gameParticle[i].isInactive()){
                                return i;
                                }
                        }
                return -1;
        }

        //spawn a particle given these parameters
        void spawnParticle(vertex pos, vertex vel, Color col, float hRad, float vRad, int shape, int c1, int c2, int c3, int c4)
        {
                int slot = getOpenParticleSlot();
                if(slot == -1) return;

                gameParticle[slot] = new particle(pos, vel, col, hRad, vRad, shape, c1, c2, c3, c4);
        }

        //spawn a particle given these parameters
        void spawnParticle(vertex pos, vertex vel, Color col, int iCol, float hRad, float vRad, int shape, int c1, int c2, int c3, int c4)
        {
                int slot = getOpenParticleSlot();
                if(slot == -1) return;

                gameParticle[slot] = new particle(pos, vel, col, iCol, hRad, vRad, shape, c1, c2, c3, c4);
        }

        //spawn a particle given these parameters
        void spawnParticle(vertex pos, vertex vel, String str, Font ft, Color col, float hRad, float vRad, int shape, int c1, int c2, int c3, int c4)
        {
                int slot = getOpenParticleSlot();
                if(slot == -1) return;

                gameParticle[slot] = new particle(pos, vel, str, ft, col, hRad, vRad, shape, c1, c2, c3, c4);
        }

        //spawn the particles that appear when the player reemerges
        void spawnPlayerAppearanceParticles()
        {
                //make a translucent highlighting circle appear first
                spawnParticle(gamePlayer.getCenterPos(), new vertex(), new Color(255, 255, 255, 40), gamePlayer.w*14, gamePlayer.h*14, particle.SHAPE_CIRCLE_FILLED, -7, gamePlayer.w/2, -1, 40);

                //now draw the concentric circle ring around the appearance position
                //spawnParticle(gamePlayer.getCenterPos(), new vertex(), gameColor(gamePlayer.color), gamePlayer.w*14, gamePlayer.h*14, 0, -7, gamePlayer.w/2, 1, 32);
                spawnParticle(gamePlayer.getCenterPos(), new vertex(), gameColor(gamePlayer.color), gamePlayer.w*13, gamePlayer.h*13, 0, -6, gamePlayer.w/2, 2, 32);
                spawnParticle(gamePlayer.getCenterPos(), new vertex(), gameColor(gamePlayer.color), gamePlayer.w*12, gamePlayer.h*12, 0, -6, gamePlayer.w/2, 2, 32);
                spawnParticle(gamePlayer.getCenterPos(), new vertex(), gameColor(gamePlayer.color), gamePlayer.w*11, gamePlayer.h*11, 0, -5, gamePlayer.w/2, 2, 32);
                spawnParticle(gamePlayer.getCenterPos(), new vertex(), gameColor(gamePlayer.color), gamePlayer.w*10, gamePlayer.h*10, 0, -5, gamePlayer.w/2, 2, 32);
                spawnParticle(gamePlayer.getCenterPos(), new vertex(), gameColor(gamePlayer.color), gamePlayer.w*9, gamePlayer.h*9, 0, -4, gamePlayer.w/2, 2, 32);
                spawnParticle(gamePlayer.getCenterPos(), new vertex(), gameColor(gamePlayer.color), gamePlayer.w*8, gamePlayer.h*8, 0, -4, gamePlayer.w/2, 2, 32);
                spawnParticle(gamePlayer.getCenterPos(), new vertex(), gameColor(gamePlayer.color), gamePlayer.w*7, gamePlayer.h*7, 0, -3, gamePlayer.w/2, 4, 32);
                spawnParticle(gamePlayer.getCenterPos(), new vertex(), gameColor(gamePlayer.color), gamePlayer.w*6, gamePlayer.h*6, 0, -3, gamePlayer.w/2, 4, 32);
                spawnParticle(gamePlayer.getCenterPos(), new vertex(), gameColor(gamePlayer.color), gamePlayer.w*5, gamePlayer.h*5, 0, -2, gamePlayer.w/2, 8, 32);
                spawnParticle(gamePlayer.getCenterPos(), new vertex(), gameColor(gamePlayer.color), gamePlayer.w*4, gamePlayer.h*4, 0, -2, gamePlayer.w/2, 8, 32);
                //spawnParticle(gamePlayer.getCenterPos(), new vertex(), new Color(255, 255, 255, 255), gamePlayer.w*7, gamePlayer.h*7, 0, -3, gamePlayer.w/2, -1, 100);

                playPlayerAppearSound();
        }

        int getRandomNegativity()
        {
                return (Math.random() < 0.5 ? -1 : 1);
        }

        //get a random velocity vector
        vertex getRandomVelocity(float hMag, float vMag)
        {
                float x = ((float)Math.random()*hMag+0.0005f)*getRandomNegativity();
                float y = ((float)Math.random()*vMag+0.0005f)*getRandomNegativity();
                return new vertex(x, y);
        }

        //gives a space on the board that's not being occupied
        vertex getRandomItemPos(int w, int h)
        {
                return new vertex((float)Math.random()*(playW-w), (float)Math.random()*(playH-h));
        }

        //find an open item slot
        int getOpenItemSlot()
        {
                for(int i = 0; i < MAX_GAME_ITEMS; i++){
                        if(gameItem[i] == null || gameItem[i].isInactive()){
                                return i;
                                }
                        }
                return -1;
        }

        //spawn an item using these parameters
        void spawnItem(vertex coords, vertex vCoords, int color, int type, int w, int h)
        {
                int slot = getOpenItemSlot();
                if(slot == -1) return;

                gameItem[slot] = new item(coords, vCoords, color, type, w, h, 100+curLevel*15);
        }

        //spawn a random item somewhere on the board
        void spawnRandomItem()
        {
                int w = ballSize;
                int h = ballSize;
                int col = (int)(Math.random()*numColors);
                //give a gradual, random increase in speed as the level # increases
                float dv = curLevel*((float)Math.random()*0.02f+0.01f);
                spawnItem(getRandomItemPos(w, h), getRandomVelocity(0.5f+dv, 0.5f+dv), col, item.TYPE_BALL, w, h);
                numItemsColored[col]++;
        }

        //spawn a random bad item somewhere on the board
        void spawnRandomBadItem()
        {
                int w = ballSize;
                int h = ballSize;
                int col = 10;
                //give a gradual, random increase in speed as the level # increases
                float dv = curLevel*((float)Math.random()*0.04f+0.0175f);
                spawnItem(getRandomItemPos(w, h), getRandomVelocity(0.6f+dv, 0.6f+dv), col, item.TYPE_BALL, w, h);
                numItemsColored[col]++;
        }

        //disable all previously active items
        void deactivateItems()
        {
                for(int i = 0; i < MAX_GAME_ITEMS; i++){
                        if(gameItem[i] != null && !gameItem[i].isInactive()){
                                gameItem[i].kill();
                                }
                        }
        }

        //initialize the item-related stuff
        void initializeItems()
        {
                //reset the previously active items
                deactivateItems();
                switch(gameMode){
                        default:
                                //reset the item color count
                                for(int i = 0; i < MAX_GAME_COLORS; i++) numItemsColored[i] = 0;
                                numItems = 20+curLevel*levelItemIncrement;
                                for(int i = 0; i < numItems; i++){
                                        spawnRandomItem();
                                        }
                                numBadItems = (curLevel+2)+curLevel/2;
                                for(int i = 0; i < numBadItems; i++){
                                        spawnRandomBadItem();
                                        }
                                curItemSpeedChange = 1.0f;
                                break;
                        }
        }

        //set the particles up before the level begins
        void initializeParticles()
        {
        }

        //set the powerups up before the level
        void initializePowerups()
        {
                resetPowerupTimer();
        }

        //set the color array up to the matching int values
        void initializeColors()
        {
                clearColor = new Color(0.85f, 0.85f, 0.85f);
                colorBank[0] = new Color(255, 0, 0);
                colorBank[1] = new Color(0, 213, 0);
                colorBank[2] = new Color(0, 71, 192);
                colorBank[3] = new Color(177, 85, 192);
                colorBank[4] = new Color(238, 237, 29);
                colorBank[5] = new Color(244, 139, 0);
                colorBank[6] = new Color(190, 190, 190);
        }

        //testing..
        Color gameColor(int col)
        {
                if(col == 0) return new Color(255, 0, 0);
                if(col == 1) return new Color(0, 213, 0);
                if(col == 2) return new Color(0, 71, 192);
                if(col == 3) return new Color(177, 85, 192);
                if(col == 4) return new Color(238, 237, 29);
                if(col == 5) return new Color(244, 139, 0);
                if(col >= 6) return new Color(190, 190, 190);
                return Color.WHITE;
        }

        //deinitialize the players
        void deinitializePlayers()
        {
        }

        //deinitialize the items
        void deinitializeItems()
        {
        }

        //get a random powerup item type
        int getRandomPowerupType()
        {
                return (int)(Math.random()*item.NUM_POWERUP_TYPES)+1;
        }

        void resetPowerupTimer()
        {
                powerupTimer = 0;
                curPowerupDuration = (int)(Math.random()*800)+500;
        }

        void powerupTimerLogic()
        {
                if(++powerupTimer >= curPowerupDuration){
                        int type = getRandomPowerupType();
                        vertex tempPos = getRandomItemPos(ballSize, ballSize);
                        spawnItem(tempPos, new vertex(), 5+type, type, ballSize, ballSize);
                        spawnParticle(new vertex(tempPos.x+ballSize/2, tempPos.y+ballSize/2), new vertex(), gameColor(type+5), ballSize, ballSize, 0, 1, ballSize*8, -20, 255);
                        resetPowerupTimer();
                        playItemAppearSound();
                        }
        }

        //handle the game timer/clock logic
        void timerLogic()
        {
                //handle item spawn timer
                //if(++itemSpawnTimer >= itemSpawnTimerEnd){
                //        spawnItem();
                //        itemSpawnTimer = 0;
                //        itemSpawnTimerEnd = (int)((float)Math.random()*(float)itemSpawnTimerScale)+50;
                //        }

                //update the game clock
                gameClock.update();

                //handle the powerup timer
                powerupTimerLogic();
        }

        //main logic stuff
        void updateApp()
        {
                //get the elapsed time slice
                long dt = gameAverageTimer.deltaT(System.currentTimeMillis());

                //convert to a float fraction of 1 sec
                float ft = (float)dt*0.001f;

                switch(gameState){
                        case GAMESTATE_TITLE:
                                titleLogic();
                                hiScoreDisplayLogic();

                                break;
                        case GAMESTATE_INITIALIZE:
                                curLevel = 0;
                                credits = DEFAULT_CREDITS;
                                curStreak = bestStreak = 0;
                                score = 0;
                                creditsScale = -1;
                                initializeColors();
                                initializeTimers();
                                initializeItems();
                                initializePlayers();
                                initializeParticles();
                                gotHiScore = false;
                                hiScoreEntryDone = false;
                                //get the highest score from the hiscore bank
                                setCurHighestScore(gameHiScoreBank.topScore(gameMode));
                                System.out.println("game initialized.. starting level..");
                                gameState = GAMESTATE_READY;
                                hiScoreStart = 0;
                                hiScoreScrollCount = 0;
                                hiScoreScrolling = 0;
                                hiScoreScrollDown = true;

                                break;
                        case GAMESTATE_LEVEL_INITIALIZE:
                                initializePlayfield();
                                initializePowerups();
                                initializeItems();
                                initializePlayers();
                                initializeParticles();
                                gameState = GAMESTATE_READY;

                                break;
                        case GAMESTATE_GAMEOVER_BEGIN:
                                deinitializePlayers();
                                deinitializeItems();
                                checkForHiScores();
								System.out.println("Hiscore check done.");

                                gameState = GAMESTATE_GAMEOVER;

                                break;
                        case GAMESTATE_GAMEOVER:
								if((gotHiScore && hiScoreEntryDone) || !gotHiScore) hiScoreDisplayLogic();

                                break;
                        default:
                                playerLogic(gamePlayer);
                                itemLogic(gameItem, MAX_GAME_ITEMS);
                                timerLogic();
                                particleLogic(gameParticle, MAX_GAME_PARTICLES);
                                break;
                        }
        }

		//play any old audio clip
		public void playClip(Clip clip)
		{
			if(!soundOn || clip == null) return;
			clip.setFramePosition(0);               //reset to frame 0
			clip.loop(0);
		}

        //play the dot absorption sound
        public void playDotAbsorbSound()
        {
                if(soundOn) playClip(soundAbsorbDot);
        }
        //play the bad dot sound
        public void playBadDotSound()
        {
                if(soundOn) playClip(soundBadDot);
        }
        //play the bounce sound
        public void playDotBounceSound()
        {
                if(soundOn) playClip(soundDotBounce[0]);
        }
        //play the slow down sound
        public void playTimeSlowSound()
        {
                if(soundOn) playClip(soundTimeSlow);
        }
        //play the speed up sound
        public void playTimeSpeedSound()
        {
                if(soundOn) playClip(soundTimeSpeed);
        }
        //play the player appearance sound
        public void playPlayerAppearSound()
        {
                if(soundOn) playClip(soundPlayerAppear);
        }
        //play the ticking sound
        public void playTickSound()
        {
                if(soundOn) playClip(soundTick);
        }
        //play the item appearance sound
        public void playItemAppearSound()
        {
                if(soundOn) playClip(soundItemAppear);
        }
        //play the explosion sound
        public void playBombSound()
        {
                if(soundOn) playClip(soundBomb);
        }
        //play the item changed by bomb sound
        public void playBombHitSound()
        {
                if(soundOn) playClip(soundBombHit);
        }
        //play the sound when an extra credit has been awarded
        public void playExtraCreditSound()
        {
                if(soundOn) playClip(soundExtraCredit);
        }
        //play the sudden death sound
        public void playSuddenDeathSound()
        {
                if(soundOn) playClip(soundSuddenDeath);
        }

        //load a font from a remote server
        public Font loadRemoteFont(String filename, int size, boolean bold)
        {
                URL url = null;
                try{
                        System.out.println("opening filename: " + filename);
                        url = new URL("http", "www.t3-i.com", filename);
                }catch(MalformedURLException e){ System.out.println("malformed URL.."); return null; }

                InputStream iStream = null;
                try{
                        System.out.println("opening inputstream at " + url.toString());
                        iStream = url.openStream();
                        }catch(IOException e){ System.out.println("error: " + e.getMessage()); return null; }

                try{
                        System.out.println("filesize: " + iStream.available() + " bytes");
                        }catch(Exception e){ }

                Font tempFont = null;

                try{
                        try{
                                tempFont = Font.createFont(Font.TRUETYPE_FONT, iStream);
                                System.out.println("font loaded: " + tempFont.toString());
                                }catch(IOException e){ System.out.println("error: " + e.getMessage()); return null; }
                        }catch(FontFormatException e){ System.out.println("error: " + e.getMessage()); return null; }

                if(tempFont == null) System.out.println("font loading failed..");
                return tempFont.deriveFont(bold ? Font.BOLD : Font.PLAIN, size);
        }

		//  loadImageSync() from http://www.spacejack.org/games/dbufanim/
        //  credits to Mike Linkovich
        //
        //  Simple method to load & wait for image synchronously
        //  rather than deal with threading.  I find this is
        //  usually more useful, however if you needed to perform
        //  other tasks while loading, then you should take advantage
        //  of Java's asynchronous getImage loads.
        //
		Image loadImageSync(String imgFile)
        {

			MediaTracker mt = null;
			Image img = null;

			//  Start loading the graphics...
			//
			if(!isApplication)
			{
				System.out.println("We're online...");
				img = getImage(getCodeBase(), imgFile);
			}
			else
			{
				URL imgURL = getClass().getResource(imgFile);
				Toolkit tk = Toolkit.getDefaultToolkit();
				System.out.println("We're in the application...");
				img = tk.getImage(imgURL);
				//img = Toolkit.getDefaultToolkit().getImage(imgFile);
				//try{ img = getImage(new File(imgFile).toURI().toURL()); } catch(Exception E){}
			}

			if(img == null) System.out.println("Image is null..");

			System.out.println("Loaded file '" + imgFile + "' with dimensions " + img.getWidth(this) + "x" + img.getHeight(this));

			mt = new MediaTracker(this);
			mt.addImage( img, 0 );

			//  Wait here 'till it's done
			//
			try
			{
	  			mt.waitForAll();
			}
			catch(Exception e)
			{
				img = null;
			};

			if(img == null || img.getWidth(this) < 0) System.err.println( "Failed to load image: '" + imgFile + "'" );

			return img;
		}

        //method for giving a string with a set number of empty spaces (long)
        public String longNumberStringEmptySpaces(long number, int length)
        {
                String temp_str = new String();
                int power = 0;
                long temp_num = number;

                while(temp_num > 0){         //divide by 10 till number is 0
                        temp_num /= 10;
                        power++;             //count the powers of ten
                        }
                length -= power;
                while(length > 0){
                        temp_str += " ";     //start with # of spaces equal to power difference
                        length--;
                        }
                if(number != 0) temp_str += Long.toString(number);  //add original # to 0'ed string

                return temp_str;
          }

        //method for giving a string with a set number of "0" spaces (long)
        public String longNumberString(long number, int length)
        {
                String temp_str = new String();
                int power = 0;
                long temp_num = number;

                while(temp_num > 0){         //divide by 10 till number is 0
                        temp_num /= 10;
                        power++;             //count the powers of ten
                        }
                length -= power;
                while(length > 0){
                        temp_str += "0";     //start with # of 0's equal to power difference
                        length--;
                        }
                if(number != 0) temp_str += Long.toString(number);  //add original # to 0'ed string

                return temp_str;
          }

        //method for giving a string with a set number of "0" spaces (int)
        public String intNumberString(int number, int length)
        {
                String temp_str = new String();
                int power = 0, temp_num = number;

                while(temp_num > 0){         //divide by 10 till number is 0
                        temp_num /= 10;
                        power++;             //count the powers of ten
                        }
                length -= power;
                while(length > 0){
                        temp_str += "0";     //start with # of 0's equal to power difference
                        length--;
                        }
                if(number != 0) temp_str += Integer.toString(number);  //add original # to 0'ed string

                return temp_str;
        }

        //keeps the supplied angle between 0 and 2pi
        public double angleMod(double angle)
	{
		if(angle < 0) return angle+Math.PI*2.0;
		else if(angle >= Math.PI*2.0) return angle-Math.PI*2.0;

		return angle;
	}

        //# items left when sudden death starts
        int suddenDeathItemCount()
        {
                return numItems/5;
        }

        //points given for finishing a level
        int levelUpScore()
        {
                return 750;
        }

        //return the current top score
        long curHighestScore()
        {
                return highestScore;
        }

        //set the current top score
        void setCurHighestScore(long hs)
        {
                highestScore = hs;
        }

        //check if we got any hiscores this game
        public void checkForHiScores()
        {
                //load the remote hiscore list first so we get the latest scores..
                loadHiScores();
				System.out.println("Checking to see if we got a hi score..");
                gotHiScore = gameHiScoreBank.isHiScoreScore(gameMode, gamePlayer.score);
                if(gotHiScore)
				{
					System.out.println("Got a hi score!");
					hiScoreEntryDone = false;
				}
				else System.out.println("No hi score. :(");
        }

        //save the current hiscores to file
        public void saveHiScores()
        {
                System.out.println("Saving scores..");
                if(isOnline) gameHiScoreBank.saveFile(curScoringMode, "/cgi/dotwrite.pl");
				else gameHiScoreBank.saveGenericFile(curScoringMode, "dcFinal.hi");
        }

        //load hiscores from file
        public void loadHiScores()
        {
                System.out.println("Loading scores..");
                if(isOnline) gameHiScoreBank.loadFile(curScoringMode, "/dotJava/hiscore.txt");
				else gameHiScoreBank.loadGenericFile(curScoringMode, "dcFinal.hi");
        }

		//start the application (graphics set-up, etc)
		public void beginApplication(Frame f, GraphicsDevice device)
		{
		      boolean isFullscreen;
		      isApplication = true;
		      if(!useFullscreen)
		      {
			         //f.setSize(APP_W+10, APP_H+30);
					 f.setSize(APP_W, APP_H+APP_WINDOWBAR_HEIGHT);
		      }
		      else
		      {
		           isFullscreen = device.isFullScreenSupported();
			       System.out.println("full screen support: " + isFullscreen);
        		   f.setUndecorated(isFullscreen);
        		   f.setResizable(!isFullscreen);
        		   if(isFullscreen)
		         	{
            			  // Full-screen mode
            			  device.setFullScreenWindow(f);
			        	  f.validate();
			      	}
				   else
				   {
			      		// Windowed mode
			            //f.pack();
						f.setSize(APP_W, APP_H+APP_WINDOWBAR_HEIGHT);
			            f.setVisible(true);
			        }
				}
		}

		//main loop (when used as application..)
		public static void main(String args[])
		{
			      final dcFinal applet = new dcFinal();
			      Frame f = new Frame(versionString);
			      GraphicsEnvironment env = GraphicsEnvironment.getLocalGraphicsEnvironment();
			      GraphicsDevice device = env.getDefaultScreenDevice();

			      f.addWindowListener(new java.awt.event.WindowAdapter()
			      {
				         public void windowClosing(java.awt.event.WindowEvent e)
				         {
					             applet.stop();
					             applet.destroy();
					             System.exit(0);
				         };
			      });

			      f.add(applet, BorderLayout.CENTER);
			      applet.beginApplication(f, device);
			      f.show();
			      applet.init();    //initialize the applet
			      applet.start();
		}
}
