import java.io.*;
import java.net.*;

class hiScoreBank
{
        final static int MAX_MODES = 20;
        final static int MAX_SCORES = 20;
        final static int SORT_BYSCORE = 0;

        hiScore[][] score = new hiScore[MAX_MODES][MAX_SCORES];
        int[] numScores = new int[MAX_MODES];

        //constructors
        public hiScoreBank()
        {
                for(int i = 0; i < MAX_MODES; i++){
                        numScores[i] = 0;
                        }
        }

        //sort the scores.. (use heap sort..) sortflag tells what to sort by
        public void sort(int mode, int sortFlag)
        {
                //no need to sort if < 2 scores in the list..
                if(numScores[mode] == 1 || numScores[mode] == 0) return;
                else if(numScores[mode] < 3){
                        switch(sortFlag){
                                case SORT_BYSCORE:
                                        if(score[mode][0].score < score[mode][1].score){
                                                hiScore tempHi = score[mode][0];
                                                score[mode][0] = score[mode][1];
                                                score[mode][1] = tempHi;
                                                }
                                        break;
                                default:
                                        break;
                                }
                        }
                else{
                        switch(sortFlag){
                                case SORT_BYSCORE:
                                        for(int i = 1; i < numScores[mode]; i++){
                                                hiScore tempHi = score[mode][i];
                                                int j = i;
                                                while(j > 0 && score[mode][j-1].score < tempHi.score){
                                                        score[mode][j] = score[mode][j-1];
                                                        j--;
                                                        }
                                                score[mode][j] = tempHi;
                                                }
                                        break;
                                default:
                                        break;
                                }
                        }
        }

        //add a new score to the score list
        public void addNewScore(int mode, int sortFlag, String nm, long sc, int streak, int lv)
        {
                //make sure we don't go out of bounds here..
                if(numScores[mode] >= MAX_SCORES) numScores[mode]--;

                score[mode][numScores[mode]] = new hiScore();
                score[mode][numScores[mode]].name = nm;
                score[mode][numScores[mode]].streak = streak;
                score[mode][numScores[mode]].score = sc;
                score[mode][numScores[mode]].level = lv;
                numScores[mode]++;
        }

        //check to see if the data passed qualifies for a spot in the hiscore table
        public boolean isHiScoreScore(int mode, long sc)
        {
                if(numScores[mode] < MAX_SCORES-1) return true;
                for(int i = numScores[mode]-1; i >= 0; i--){
                        if(sc > score[mode][i].score) return true;
                        }
                return false;
        }

		//initialize a dummy scoreboard with this as the top score
		public void initializeDummyScores(int mode, long bestScore)
		{
				long sc = bestScore;
				long sd = bestScore/10;
				numScores[mode] = 0;
				System.out.println("Initializing dummy scores..");
				addNewScore(mode, SORT_BYSCORE, "Alistair", bestScore, (int)(Math.random()*15)+5, (int)(Math.random()*3)+1);
				addNewScore(mode, SORT_BYSCORE, "Johnson", bestScore-sd, (int)(Math.random()*15)+5, (int)(Math.random()*3)+1);
				addNewScore(mode, SORT_BYSCORE, "Brock", bestScore-sd*2, (int)(Math.random()*15)+5, (int)(Math.random()*3)+1);
				addNewScore(mode, SORT_BYSCORE, "Walt", bestScore-sd*3, (int)(Math.random()*15)+5, (int)(Math.random()*3)+1);
				addNewScore(mode, SORT_BYSCORE, "Donald", bestScore-sd*4, (int)(Math.random()*15)+5, (int)(Math.random()*3)+1);
				addNewScore(mode, SORT_BYSCORE, "Dotter", bestScore-sd*5, (int)(Math.random()*15)+5, (int)(Math.random()*3)+1);
				addNewScore(mode, SORT_BYSCORE, "Blacksmith", bestScore-sd*6, (int)(Math.random()*15)+5, (int)(Math.random()*3)+1);
				addNewScore(mode, SORT_BYSCORE, "Greenberg", bestScore-sd*7, (int)(Math.random()*15)+5, (int)(Math.random()*3)+1);
				addNewScore(mode, SORT_BYSCORE, "Buddy", bestScore-sd*8, (int)(Math.random()*15)+5, (int)(Math.random()*3)+1);
				addNewScore(mode, SORT_BYSCORE, "Dane", bestScore-sd*9, (int)(Math.random()*15)+5, (int)(Math.random()*3)+1);
				addNewScore(mode, SORT_BYSCORE, "Greg", bestScore, (int)(Math.random()*15)+5, (int)(Math.random()*3)+1);
				addNewScore(mode, SORT_BYSCORE, "Emilio", bestScore-sd, (int)(Math.random()*15)+5, (int)(Math.random()*3)+1);
				addNewScore(mode, SORT_BYSCORE, "Jeff", bestScore-sd*2, (int)(Math.random()*15)+5, (int)(Math.random()*3)+1);
				addNewScore(mode, SORT_BYSCORE, "Tarantula", bestScore-sd*3, (int)(Math.random()*15)+5, (int)(Math.random()*3)+1);
				addNewScore(mode, SORT_BYSCORE, "Ludwig", bestScore-sd*4, (int)(Math.random()*15)+5, (int)(Math.random()*3)+1);
				addNewScore(mode, SORT_BYSCORE, "J.S.", bestScore-sd*5, (int)(Math.random()*15)+5, (int)(Math.random()*3)+1);
				addNewScore(mode, SORT_BYSCORE, "Amadeus", bestScore-sd*6, (int)(Math.random()*15)+5, (int)(Math.random()*3)+1);
				addNewScore(mode, SORT_BYSCORE, "Spurlock", bestScore-sd*7, (int)(Math.random()*15)+5, (int)(Math.random()*3)+1);
				addNewScore(mode, SORT_BYSCORE, "Benito", bestScore-sd*8, (int)(Math.random()*15)+5, (int)(Math.random()*3)+1);
				addNewScore(mode, SORT_BYSCORE, "Barry", bestScore-sd*9, (int)(Math.random()*15)+5, (int)(Math.random()*3)+1);
		}

		//load the scores from any plain text file
		public void loadGenericFile(int mode, String filename)
		{
				int numDataVars = 4;
				//String[] tempStr = new String[MAX_SCORES*numDataVars];

				System.out.println("loading data from hiscore file " + filename + "...");
				//tempStr = tempStream.loadData(filename, MAX_SCORES*numDataVars);
				int count = 0;
				String[] tempStr2 = new String[MAX_SCORES*numDataVars];
				numScores[mode] = 0;
				boolean localFileExists = true;     //use this to see if we've got a hiscore.txt saved already

				try
				{
					URL fileURL = null;
					BufferedReader bufferedReader = null;
					FileReader fileReader = null;

					// FileReader reads text files in the default encoding.
					try{ fileReader = new FileReader(filename); }
					catch(Exception E)   //if the file can't be read here, that means it doesn't exist yet locally..
					{
						localFileExists = false;
					}
					//FileReader fileReader = new FileReader(fileURL);

					if(localFileExists)
					{
						System.out.println("Hiscore file exists, so loading file for data extraction..");
						bufferedReader = new BufferedReader(fileReader);
						//bufferedReader = new BufferedReader(new InputStreamReader(getClass().getResourceAsStream(filename)));
					}
					else
					{
						System.out.println("Hiscore file doesn't exist, so setting initial hiscore board...");
						initializeDummyScores(mode, 15000);
						return;
					}

					tempStr2[0] = "NULL";

					if(tempStr2[0] == null) System.out.println("score 0 is null...");

					//keep going until there aren't any more words found in the string array
					while(count < MAX_SCORES) // && tempStr2[count*numDataVars] != null)
					{
						for(int i = 0; i < numDataVars; i++)
						{
							tempStr2[i] = bufferedReader.readLine();
							//break out if we reach an empty line or EOF
							if(tempStr2[i] == null) break;
							System.out.println("Line #" + count*numDataVars+i + ": " + tempStr2[i]);
							//tempStr2[i] = tempStr[count*numDataVars+i];
							//System.out.println(tempStr2[i]);
						}
						addNewScore(mode, SORT_BYSCORE, tempStr2[0], Long.parseLong(tempStr2[1]), Integer.parseInt(tempStr2[2]), Integer.parseInt(tempStr2[3]));
						count++;
					}

					// Always close files.
					bufferedReader.close();
				}
				catch(FileNotFoundException ex)
				{
					System.out.println("Unable to open file '" + filename + "'");
					initializeDummyScores(mode, 15000);
				}
				catch(IOException ex)
				{
					System.out.println("Error reading file '" + filename + "'");
					initializeDummyScores(mode, 15000);
				}
		}

        //load the scores from a file
        public void loadFile(int mode, String filename)
        {
                remoteStream tempStream = new remoteStream("www.t3-i.com", "");
                int numDataVars = 4;
                String[] tempStr = new String[MAX_SCORES*numDataVars];

                System.out.println("loading data from remote server..");
                tempStr = tempStream.loadData(filename, MAX_SCORES*numDataVars);
                int count = 0;
                String[] tempStr2 = new String[numDataVars];
                numScores[mode] = 0;

                //keep going until there aren't any more words found in the string array
                while(count < MAX_SCORES && tempStr[count*numDataVars] != null){
                        for(int i = 0; i < numDataVars; i++){
                                tempStr2[i] = tempStr[count*numDataVars+i];
                                System.out.println(tempStr2[i]);
                                }
                        addNewScore(mode, SORT_BYSCORE, tempStr2[0], Long.parseLong(tempStr2[1]), Integer.parseInt(tempStr2[2]), Integer.parseInt(tempStr2[3]));
                        count++;
                        }
        }

		//save scores to a local file
		public void saveGenericFile(int mode, String wp)
		{
				int numDataVars = 4;
				String tempStr = "";
				PrintWriter out = null;
				for(int i = 0; i < numScores[mode]; i++){
						tempStr += score[mode][i].name;
						tempStr += "\n";
						tempStr += score[mode][i].score;
						tempStr += "\n";
						tempStr += score[mode][i].streak;
						tempStr += "\n";
						tempStr += score[mode][i].level;
						tempStr += "\n";
                        }

				System.out.println("Saving score data to file...");
				try{ out = new PrintWriter(wp); } catch(Exception E){ System.out.println("Error creating PrintWriter."); }

				out.print(tempStr);
				out.close();
		}

        //save the scores to a file
        public void saveFile(int mode, String wp)
        {
                remoteStream tempStream = new remoteStream("www.t3-i.com", wp);

                int numDataVars = 4;
                String tempStr = "";
                for(int i = 0; i < numScores[mode]; i++){
                        tempStr += score[mode][i].name;
                        tempStr += "\n";
                        tempStr += score[mode][i].score;
                        tempStr += "\n";
                        tempStr += score[mode][i].streak;
                        tempStr += "\n";
                        tempStr += score[mode][i].level;
                        tempStr += "\n";
                        }
                System.out.println("Sending data to remote server..");
                try{
                        tempStream.sendData(tempStr);
                        }
                catch(Exception e){
                        System.out.println("an exception has occured:" + e.getMessage());
                        }
        }

        //get the current top score
        long topScore(int m)
        {
                return (numScores[m] > 0 ? score[m][0].score : 0);
        }
}
