import java.awt.*;
import java.awt.event.*;
import java.awt.image.*;

class particle
{
        final static int SHAPE_CIRCLE = 0;
        final static int SHAPE_RECT = 1;
        final static int SHAPE_CIRCLE_FILLED = 2;
        final static int SHAPE_RECT_FILLED = 3;
        final static int SHAPE_BOMB = 4;
        final static int SHAPE_TEXT = 5;
        final static int MODE_INACTIVE = 0;
        final static int MODE_ACTIVE = 1;

        vertex pos, vel;
        float hRad, vRad;
        Color color;
        Font font;
        int iColor;
        int shape;
        int c1, c2;
        int c3, c4;     //counters/timer increments
        int alpha;
        int mode;
        String txt = null;     //text (if used)

        void setDefaults()
        {
                hRad = vRad = 0.0f;
                color = new Color(255, 255, 255, 255);
                alpha = 255;
                shape = SHAPE_CIRCLE;
                c1 = c2 = 0;
                c3 = c4 = 0;
                mode = MODE_ACTIVE;
                iColor = 10;
                txt = null;
        }

        //set the font to this font..
        public void setFont(Font ft)
        {
                font = ft;
        }

        public void kill()
        {
                mode = MODE_INACTIVE;
        }

        //handle this particle's logic
        public void logic()
        {
                pos.add(vel);
                hRad += c1;
                vRad += c1;
                alpha += c3;
                if((c1 >= 0 ? hRad >= c2 : hRad <= c2) || alpha < 0 || alpha > 255){
                        alpha = 0;
                        kill();
                        }
                color = new Color(color.getRed(), color.getGreen(), color.getBlue(), alpha);

        }

        //various activity indicators
        public boolean isActive(){ return mode == MODE_ACTIVE; }
        public boolean isInactive(){ return mode == MODE_INACTIVE; }
        public boolean isHittable(){ return shape == SHAPE_BOMB; }

        //constructors
        public particle(vertex coords, vertex vCoords, Color col, float hR, float vR, int sh, int ca, int cb, int cc, int cd)
        {
                setDefaults();
                pos = new vertex(coords.x, coords.y, coords.z);
                vel = new vertex(vCoords.x, vCoords.y, vCoords.z);
                hRad = hR;
                vRad = vR;
                c1 = ca;
                c2 = cb;
                c3 = cc;
                c4 = alpha = cd;
                shape = sh;
                color = new Color(col.getRed(), col.getGreen(), col.getBlue(), alpha);
                iColor = 0;
                //color = new Color(col.getRed(), col.getGreen(), col.getBlue(), alpha = cd);
        }
        public particle(vertex coords, vertex vCoords, Color col, int iCol, float hR, float vR, int sh, int ca, int cb, int cc, int cd)
        {
                setDefaults();
                pos = new vertex(coords.x, coords.y, coords.z);
                vel = new vertex(vCoords.x, vCoords.y, vCoords.z);
                hRad = hR;
                vRad = vR;
                c1 = ca;
                c2 = cb;
                c3 = cc;
                c4 = alpha = cd;
                shape = sh;
                color = new Color(col.getRed(), col.getGreen(), col.getBlue(), alpha);
                iColor = iCol;
                //color = new Color(col.getRed(), col.getGreen(), col.getBlue(), alpha = cd);
        }
        public particle(vertex coords, vertex vCoords, String str, Font ft, Color col, float hR, float vR, int sh, int ca, int cb, int cc, int cd)
        {
                setDefaults();
                pos = new vertex(coords.x, coords.y, coords.z);
                vel = new vertex(vCoords.x, vCoords.y, vCoords.z);
                hRad = hR;
                vRad = vR;
                c1 = ca;
                c2 = cb;
                c3 = cc;
                c4 = alpha = cd;
                shape = sh;
                color = new Color(col.getRed(), col.getGreen(), col.getBlue(), alpha);
                txt = new String(str);
                setFont(ft);
                //color = new Color(col.getRed(), col.getGreen(), col.getBlue(), alpha = cd);
        }
        public particle()
        {
                setDefaults();
                pos = new vertex();
                vel = new vertex();
        }

        //handle particle display
        public void draw(Graphics g, ImageObserver im, dirtyRectBank db)
        {
                g.setColor(color);
                switch(shape){
                        case SHAPE_CIRCLE:
                                g.drawOval((int)(pos.x-hRad), (int)(pos.y-vRad), (int)hRad*2, (int)vRad*2);
                                break;
                        case SHAPE_RECT:
                                g.drawRect((int)(pos.x-hRad), (int)(pos.y-vRad), (int)hRad*2, (int)vRad*2);
                                break;
                        case SHAPE_CIRCLE_FILLED:
                                g.fillOval((int)(pos.x-hRad), (int)(pos.y-vRad), (int)hRad*2, (int)vRad*2);
                                break;
                        case SHAPE_RECT_FILLED:
                                g.fillRect((int)(pos.x-hRad), (int)(pos.y-vRad), (int)hRad*2, (int)vRad*2);
                                break;
                        case SHAPE_BOMB:
                                g.fillOval((int)(pos.x-hRad), (int)(pos.y-vRad), (int)hRad*2, (int)vRad*2);
                                break;
                        case SHAPE_TEXT:
                                g.setFont(font);
                                g.drawString(txt, (int)pos.x, (int)pos.y);
                                break;
                        default:
                                break;
                        }
                db.addRect((int)(pos.x-(hRad+1)), (int)(pos.y-(vRad+1)), (int)(hRad+1)*2, (int)(vRad+1)*2);
        }
}
