import java.awt.*;
import java.awt.event.*;
import java.awt.image.*;

class dirtyRectBank
{
        final static int MAX_RECTS = 256;

        int numRects;
        int[] rectX = new int[MAX_RECTS];
        int[] rectY = new int[MAX_RECTS];
        int[] rectW = new int[MAX_RECTS];
        int[] rectH = new int[MAX_RECTS];
        boolean[] rectCleared = new boolean[MAX_RECTS];

        public void addRect(int x, int y, int w, int h)
        {
                rectX[numRects] = x;
                rectY[numRects] = y;
                rectW[numRects] = w;
                rectH[numRects] = h;
                rectCleared[numRects] = false;

                if(++numRects >= MAX_RECTS)
				{
					//System.out.println("Max rects reached. (" + numRects + ")");
					numRects = MAX_RECTS-1;
				}
        }

        public void clear(Graphics g, ImageObserver im, Color color)
        {
                g.setColor(color);
                for(int i = 0; i < numRects; i++)
				{
                        g.fillRect(rectX[i], rectY[i], rectW[i], rectH[i]);
                }
                numRects = 0;
        }

		public void clearAsOval(Graphics g, ImageObserver im, Color color)
		{
			g.setColor(color);
			for(int i = 0; i < numRects; i++)
			{
					g.fillOval(rectX[i], rectY[i], rectW[i], rectH[i]);
			}
			numRects = 0;
		}

        public dirtyRectBank()
        {
                numRects = 0;
        }
}
