/* this is a generic template that I use as a starting point for my java applets */
/* yeah, I'm that lazy */

import java.applet.*;
import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;
import java.awt.image.*;
import java.io.*;
import java.net.*;
import java.text.*;

public class temp extends Applet implements Runnable, KeyListener, MouseListener, MouseMotionListener
{
        //applet dimensions
        final static int APP_W = 400;
        final static int APP_H = 300;
        final static float FAPP_W = (float)APP_W;
        final static float FAPP_H = (float)APP_H;

        final static int GAMESTATE_TITLE = -1;
        final static int GAMESTATE_INITIALIZE = 0;
        final static int GAMESTATE_READY = 1;
        final static int GAMESTATE_LEVELUP = 2;
        final static int GAMESTATE_GAMEOVER_BEGIN = 3;
        final static int GAMESTATE_GAMEOVER = 4;

        final static int MAX_PLAYER_NAME_LENGTH = 32;

        boolean isOnline = false;   //are we playing in a browser?

        int gameState = GAMESTATE_INITIALIZE;

        //heads up display dimensions
        int hudW = APP_W;
        int hudH = 40;

        //playing area dimensions
        int playW = APP_W;
        int playH = APP_H-hudH;

        int curScoringMode = 0;
        boolean gotHiScore = false;
        boolean hiScoreEntryDone = false;

        vertex playFieldPos;
        vertex hudPos = new vertex(0.0f, FAPP_H-(float)hudH);   //placement of the heads up display (score, etc.)
        vertex hudEnergyPos = new vertex(79, 7);
        vertex hudScorePos = new vertex(55, 14);
        vertex hudHiScorePos = new vertex(55, 32);
        vertex hudLevelPos = new vertex(375, 18);
        vertex hudClockPos = new vertex(134, 25);

        //hiscore entry stuff
        String playerNameString = "";     //player name string for hiscore entry

        Thread mainThread = null;        //main thread
        Color borderClearColor = new Color(0, 96, 128);  //border background color
        Color clearColor = new Color(0.8f, 0.8f, 0.8f);  //background color
        Color gridColor = new Color(0.75f, 0.75f, 0.75f);
        Color hudColor = new Color(0.6f,0.6f,0.6f,1.0f);   //the color used for the heads up display

        Image img_scBuff = null;         //screen buffer
        Graphics g_scBuff = null;        //screen buffer graphics context
        Font gameFont = null;
        Font hudFont = null;
        int fontW = 8, fontH = 10;
//        Font mySpecialFont = Font.createFont(Font.TRUETYPE_FONT, getClass().getResourceAsStream("myfont.ttf"));
        Image hudImage = null;           //heads up display bitmap

        AverageTimer gameAverageTimer = null;   //average time for display sync
        
        clock gameClock = new clock();           //game clock

        hiScoreBank gameHiScoreBank = new hiScoreBank();  //game high scores listings

        //applet init sequence
        public void init()
        {
                setBackground(clearColor);  //set bg color
                resize(APP_W, APP_H);       //set applet dimensions

                //create screen buffer
                try{
                        img_scBuff = createImage(APP_W, APP_H);
                        g_scBuff = img_scBuff.getGraphics();
                        }
                catch(Exception e){
                        System.out.println("screen buffer not created..");
                        img_scBuff = null;
                        g_scBuff = null;
                        return;
                        }

                g_scBuff.setColor(clearColor);
                g_scBuff.fillRect(0, 0, APP_W, APP_H);

                //add listeners
                addMouseListener(this);
                addMouseMotionListener(this);
                addKeyListener(this);

                //load saved hiscores
        }

        //start the main thread
        public void start()
        {
                if(mainThread == null){
                        mainThread = new Thread(this);
                        mainThread.start();   //invokes run()
                        }
        }

        //kill the main thread
        public void stop()
        {
                mainThread = null;
        }

        //draw stuff to the screen
        public void paint(Graphics g)
        {
                if(img_scBuff != null){
                        g.drawImage(img_scBuff, 0, 0, this);  //draw the screen buffer to the graphics context
                        }
        }

        //update the supplied graphics context
        public void update(Graphics g)
        {
                paint(g);
        }

        public void run()
        {
                System.out.println("applet starting...");

                if(g_scBuff == null) return; //make sure double buffer created properly

                Graphics g = getGraphics();

                //register font
                g.setFont(gameFont);
                g_scBuff.setFont(gameFont);

                //make sure initialization occurs without incident
                if(!initApp(g)) return;

                System.out.println("entering main loop...");

                //keep looping until the thread is killed
                while(mainThread != null){
                        updateApp();  //handle logic
                        paintApp(g);  //handle display

                        try{   //take a little nap
                                Thread.sleep(10);
                                }catch(InterruptedException e) { stop(); }
                        }

                System.out.println("applet cleanly exited.");
        }

        //load all the images up before we start going
        void loadGameImages(Graphics g)
        {
        }

        //set the hiscore stuff up
        void initializeHiScoreStuff()
        {
                if(isOnline){
                        loadHiScores();
                        }
                //setDummyScoreboard();
        }

        //applet initialization sequence
        boolean initApp(Graphics g)
        {
                //start the average timer..
                gameAverageTimer = new AverageTimer( System.currentTimeMillis() );

                //register the font
                gameFont = new Font("monospaced", Font.BOLD, fontH);
                hudFont = new Font("sansserif", Font.BOLD, 10);

                g.drawString("Loading game images..", 0, fontH*2);
                //load game image files
                loadGameImages(g);

                g.drawString("Loading hiscores from server..", 0, fontH*4);
                //set the hiscore-related stuff up
                initializeHiScoreStuff();

                //ah! success!
                return true;
        }

        //keyboard listener stuff
        public void keyPressed(KeyEvent e){
                if(gameState == GAMESTATE_READY){
                        }
                else if(gameState == GAMESTATE_GAMEOVER){
                        }
                }
        public void keyReleased(KeyEvent e){
                }
        public void keyTyped(KeyEvent e){
                }

        //mouse listener stuff
        public void mousePressed(MouseEvent e){ }
        public void mouseClicked(MouseEvent e)
        {
                switch(gameState){
                        case GAMESTATE_TITLE:  //start the game on click
                                gameState = GAMESTATE_INITIALIZE;

                                break;
                        case GAMESTATE_GAMEOVER:  //restart the game on click
                                gameState = GAMESTATE_INITIALIZE;

                                break;
                        default:
                                break;
                        }
        }

        public void mouseEntered(MouseEvent e){ }
        public void mouseExited(MouseEvent e){ }
        public void mouseReleased(MouseEvent e){ }
        public void mouseDragged(MouseEvent e){ }
        public void mouseMoved(MouseEvent e){ }        

        //draw the clock all digital-like
        void clockDisplay(Graphics g, clock co, int x, int y, Color color, int fontSize)
        {
                Font clockFont = new Font("monospaced", Font.BOLD, fontSize);
                g.setColor(color);
                g.drawString("" + intNumberString(co.mins, 2) + ":" + intNumberString(co.secs, 2), x, y);
        }

        //handle player drawing stuff
        void playerDisplay(Graphics g, player pl)
        {
        }

        //handle drawing the items
        void itemDisplay(Graphics g, item it[], int numItems)
        {
        }

        //draw the grid overlay (if we use it?)
        void gridDisplay(Graphics g)
        {
        }

        //draw the scrolling backdrop
        void backgroundDisplay(Graphics g)
        {
                //draw the play area
                //g.setColor(clearColor);
                //g.fillRect((int)playFieldPos.x, (int)playFieldPos.y, playW, playH);
                //gridDisplay(g);

                //draw the black border around the play area
                //g.setColor(Color.black);
                //g.drawRect((int)playFieldPos.x, (int)playFieldPos.y, playW, playH);
        }

        //draw the hud/status stuff
        void foregroundDisplay(Graphics g)
        {
        }

        //draw the title screen
        void titleDisplay(Graphics g)
        {
        }

        //draw the hiscore listing box
        void hiScoreListingDisplay(Graphics g)
        {
        }

        //tells if the hiscores list is currently showing
        boolean hiScoresListShowing()
        {
                return !gotHiScore && hiScoreEntryDone;
        }

        //draw the hiscore entry box
        void hiScoreEntryDisplay(Graphics g)
        {
        }

        //draw the game over screen
        void gameOverDisplay(Graphics g)
        {
        }

        //display method (run() calls this each frame)
        void paintApp(Graphics g)
        {
                backgroundDisplay(g_scBuff);

                switch(gameState){
                        case GAMESTATE_TITLE: //draw the title screen
                                titleDisplay(g_scBuff);

                                break;
                        case GAMESTATE_READY:
                                //itemDisplay(g_scBuff, gameItem, MAX_ITEMS);
                                //playerDisplay(g_scBuff, playerViper);

                                break;
                        case GAMESTATE_GAMEOVER: //draw the game over screen
                                gameOverDisplay(g_scBuff);

                                break;
                        default:
                                break;
                        }
                
                //draw the status/hud, etc.
                foregroundDisplay(g_scBuff);
                
                //draw the screen buffer to screen
                g.drawImage(img_scBuff, 0, 0, this);
        }


        //handle player logic routines
        void playerLogic(player pl)
        {
        }

        //handle all item-related logic..
        void itemLogic(item it[], int numItems)
        {
        }

        //handle the title screen stuff
        void titleLogic()
        {
        }

        //handle the hiscore listing screen stuff
        void hiScoreDisplayLogic()
        {
        }

        //handle the game over screen stuff
        void gameOverLogic()
        {
        }

        //add the player's score/data to the hiscore bank
        void addNewHiScore()
        {
                //gameHiScoreBank.addNewScore(curScoringMode, gameHiScoreBank.SORT_BYSCORE, playerNameString, playerShip.score, playerShip.bestWord, curLevel, playerShip.curAccuracy, playerShip.curWPM);
                //gameHiScoreBank.sort(curScoringMode, gameHiScoreBank.SORT_BYSCORE);
                //if(isOnline) saveHiScores();
        }
        
        //hiscore name entry completed, now let's finish up
        void finishHiScoreEntry()
        {
                hiScoreEntryDone = true;
                gotHiScore = false;
                addNewHiScore();
        }

        //initialize all the timers we're working with
        void initializeTimers()
        {
                //set the game clock up
                gameClock.reset();
        }

        //initialize the players
        void initializePlayers()
        {
        }

        //initialize the playfield stuff
        void initializePlayfield()
        {
        }

        //initialize the item-related stuff
        void initializeItems()
        {
        }
        
        //deinitialize the players
        void deinitializePlayers()
        {
        }
        
        //deinitialize the items
        void deinitializeItems()
        {
        }
        
        //handle the game timer/clock logic
        void timerLogic()
        {
                //handle item spawn timer
                //if(++itemSpawnTimer >= itemSpawnTimerEnd){
                //        spawnItem();
                //        itemSpawnTimer = 0;
                //        itemSpawnTimerEnd = (int)((float)Math.random()*(float)itemSpawnTimerScale)+50;
                //        }

                //update the game clock
                gameClock.update();
        }

        //main logic stuff
        void updateApp()
        {
                //get the elapsed time slice
                long dt = gameAverageTimer.deltaT(System.currentTimeMillis());

                //convert to a float fraction of 1 sec
                float ft = (float)dt*0.001f;

                switch(gameState){
                        case GAMESTATE_TITLE:
                                titleLogic();

                                break;
                        case GAMESTATE_INITIALIZE:
                                initializePlayfield();
                                initializeTimers();
                                initializePlayers();
                                initializeItems();
                                gotHiScore = false;
                                hiScoreEntryDone = false;
                                System.out.println("game initialized.. starting level..");
                                gameState = GAMESTATE_READY;

                                break;
                        case GAMESTATE_GAMEOVER_BEGIN:
                                deinitializePlayers();
                                deinitializeItems();
                                if(isOnline) checkForHiScores();

                                gameState = GAMESTATE_GAMEOVER;

                                break;
                        case GAMESTATE_GAMEOVER:
                                gameOverLogic();

                                break;
                        default:
                                //playerLogic(playerViper);
                                //itemLogic(gameItem, MAX_ITEMS);
                                timerLogic();
                                break;
                        }
        }

        //  loadImageSync() from http://www.spacejack.org/games/dbufanim/
        //  credits to Mike Linkovich
        //
        //  Simple method to load & wait for image synchronously
        //  rather than deal with threading.  I find this is
        //  usually more useful, however if you needed to perform
        //  other tasks while loading, then you should take advantage
        //  of Java's asynchronous getImage loads.
        //
        Image loadImageSync(String imgFile)
        {
                MediaTracker mt;
                Image img;

                //  Start loading the graphics...
                //
                img = getImage(getCodeBase(), imgFile);
                mt = new MediaTracker(this);
                mt.addImage( img, 0 );

                //  Wait here 'till it's done
                //
                try
                {
                        mt.waitForAll();
                } catch(Exception e) { img = null; };

                if( img == null || img.getWidth(this) < 0 )
                System.err.println( "Failed to load image: '" + imgFile + "'" );

                return img;
        }

        //method for giving a string with a set number of "0" spaces (long)
        public String longNumberString(long number, int length)
        {
                String temp_str = new String();
                int power = 0;
                long temp_num = number;

                while(temp_num > 0){         //divide by 10 till number is 0
                        temp_num /= 10;
                        power++;             //count the powers of ten
                        }
                length -= power;
                while(length > 0){
                        temp_str += "0";     //start with # of 0's equal to power difference
                        length--;
                        }
                if(number != 0) temp_str += Long.toString(number);  //add original # to 0'ed string

                return temp_str;
          }

        //method for giving a string with a set number of "0" spaces (int)
        public String intNumberString(int number, int length)
        {
                String temp_str = new String();
                int power = 0, temp_num = number;

                while(temp_num > 0){         //divide by 10 till number is 0
                        temp_num /= 10;
                        power++;             //count the powers of ten
                        }
                length -= power;
                while(length > 0){
                        temp_str += "0";     //start with # of 0's equal to power difference
                        length--;
                        }
                if(number != 0) temp_str += Integer.toString(number);  //add original # to 0'ed string

                return temp_str;
        }

        //check if we got any hiscores this game
        public void checkForHiScores()
        {
                //gotHiScore = gameHiScoreBank.isHiScoreScore(playerViper.length);
                //if(gotHiScore) hiScoreEntryDone = false;
        }

        //save the current hiscores to file
        public void saveHiScores()
        {
                //System.out.println("Saving scores..");
                //gameHiScoreBank.saveFile(curScoringMode, "/cgi/vwrite.pl");
        }

        //load hiscores from file
        public void loadHiScores()
        {
                //System.out.println("Loading scores..");
                //gameHiScoreBank.loadFile(curScoringMode, "/viperJava/hiscore.txt");
        }
}
